﻿using System.Collections.Generic;
using POGOProtos.Enums;

namespace PoGo.PokeMobBot.Logic.PoGoUtils
{
    public static class PokeRareStatus
    {
        private static readonly Dictionary<PokemonId, int> RareStatus = new Dictionary<PokemonId, int>
        {
            {PokemonId.Missingno, 1},
            {PokemonId.Bulbasaur, 4},
            {PokemonId.Ivysaur, 6},
            {PokemonId.Venusaur, 9},
            {PokemonId.Charmander, 4},
            {PokemonId.Charmeleon, 6},
            {PokemonId.Charizard, 9},
            {PokemonId.Squirtle, 4},
            {PokemonId.Wartortle, 6},
            {PokemonId.Blastoise, 9},
            {PokemonId.Caterpie, 2},
            {PokemonId.Metapod, 2},
            {PokemonId.Butterfree, 6},
            {PokemonId.Weedle, 2},
            {PokemonId.Kakuna, 2},
            {PokemonId.Beedrill, 6},
            {PokemonId.Pidgey, 3},
            {PokemonId.Pidgeotto, 5},
            {PokemonId.Pidgeot, 8},
            {PokemonId.Rattata, 3},
            {PokemonId.Raticate, 6},
            {PokemonId.Spearow, 3},
            {PokemonId.Fearow, 6},
            {PokemonId.Ekans, 3},
            {PokemonId.Arbok, 6},
            {PokemonId.Pikachu, 4},
            {PokemonId.Raichu, 7},
            {PokemonId.Sandshrew, 4},
            {PokemonId.Sandslash, 8},
            {PokemonId.NidoranFemale, 3},
            {PokemonId.Nidorina, 6},
            {PokemonId.Nidoqueen, 9},
            {PokemonId.NidoranMale, 3},
            {PokemonId.Nidorino, 6},
            {PokemonId.Nidoking, 9},
            {PokemonId.Clefairy, 5},
            {PokemonId.Clefable, 9},
            {PokemonId.Vulpix, 3},
            {PokemonId.Ninetales, 8},
            {PokemonId.Jigglypuff, 5},
            {PokemonId.Wigglytuff, 9},
            {PokemonId.Zubat, 3},
            {PokemonId.Golbat, 7},
            {PokemonId.Oddish, 4},
            {PokemonId.Gloom, 6},
            {PokemonId.Vileplume, 9},
            {PokemonId.Paras, 4},
            {PokemonId.Parasect, 7},
            {PokemonId.Venonat, 4},
            {PokemonId.Venomoth, 7},
            {PokemonId.Diglett, 1},
            {PokemonId.Dugtrio, 4},
            {PokemonId.Meowth, 3},
            {PokemonId.Persian, 6},
            {PokemonId.Psyduck, 5},
            {PokemonId.Golduck, 8},
            {PokemonId.Mankey, 4},
            {PokemonId.Primeape, 7},
            {PokemonId.Growlithe, 5},
            {PokemonId.Arcanine, 9},
            {PokemonId.Poliwag, 4},
            {PokemonId.Poliwhirl, 6},
            {PokemonId.Poliwrath, 9},
            {PokemonId.Abra, 3},
            {PokemonId.Kadabra, 5},
            {PokemonId.Alakazam, 7},
            {PokemonId.Machop, 3},
            {PokemonId.Machoke, 6},
            {PokemonId.Machamp, 8},
            {PokemonId.Bellsprout, 4},
            {PokemonId.Weepinbell, 6},
            {PokemonId.Victreebel, 9},
            {PokemonId.Tentacool, 4},
            {PokemonId.Tentacruel, 8},
            {PokemonId.Geodude, 4},
            {PokemonId.Graveler, 6},
            {PokemonId.Golem, 9},
            {PokemonId.Ponyta, 5},
            {PokemonId.Rapidash, 7},
            {PokemonId.Slowpoke, 5},
            {PokemonId.Slowbro, 9},
            {PokemonId.Magnemite, 4},
            {PokemonId.Magneton, 5},
            {PokemonId.Farfetchd, 4},
            {PokemonId.Doduo, 3},
            {PokemonId.Dodrio, 7},
            {PokemonId.Seel, 5},
            {PokemonId.Dewgong, 9},
            {PokemonId.Grimer, 5},
            {PokemonId.Muk, 9},
            {PokemonId.Shellder, 3},
            {PokemonId.Cloyster, 8},
            {PokemonId.Gastly, 4},
            {PokemonId.Haunter, 6},
            {PokemonId.Gengar, 7},
            {PokemonId.Onix, 4},
            {PokemonId.Drowzee, 5},
            {PokemonId.Hypno, 8},
            {PokemonId.Krabby, 4},
            {PokemonId.Kingler, 7},
            {PokemonId.Voltorb, 4},
            {PokemonId.Electrode, 6},
            {PokemonId.Exeggcute, 5},
            {PokemonId.Exeggutor, 10},
            {PokemonId.Cubone, 4},
            {PokemonId.Marowak, 6},
            {PokemonId.Hitmonlee, 6},
            {PokemonId.Hitmonchan, 6},
            {PokemonId.Lickitung, 7},
            {PokemonId.Koffing, 4},
            {PokemonId.Weezing, 7},
            {PokemonId.Rhyhorn, 5},
            {PokemonId.Rhydon, 9},
            {PokemonId.Chansey, 6},
            {PokemonId.Tangela, 7},
            {PokemonId.Kangaskhan, 8},
            {PokemonId.Horsea, 4},
            {PokemonId.Seadra, 6},
            {PokemonId.Goldeen, 4},
            {PokemonId.Seaking, 7},
            {PokemonId.Staryu, 4},
            {PokemonId.Starmie, 8},
            {PokemonId.MrMime, 5},
            {PokemonId.Scyther, 8},
            {PokemonId.Jynx, 6},
            {PokemonId.Electabuzz, 8},
            {PokemonId.Magmar, 7},
            {PokemonId.Pinsir, 7},
            {PokemonId.Tauros, 8},
            {PokemonId.Magikarp, 6},
            {PokemonId.Gyarados, 9},
            {PokemonId.Lapras, 10},
            {PokemonId.Ditto, 10},
            {PokemonId.Eevee, 5},
            {PokemonId.Vaporeon, 9},
            {PokemonId.Jolteon, 8},
            {PokemonId.Flareon, 8},
            {PokemonId.Porygon, 5},
            {PokemonId.Omanyte, 5},
            {PokemonId.Omastar, 9},
            {PokemonId.Kabuto, 5},
            {PokemonId.Kabutops, 8},
            {PokemonId.Aerodactyl, 8},
            {PokemonId.Snorlax, 9},
            {PokemonId.Articuno, 10},
            {PokemonId.Zapdos, 10},
            {PokemonId.Moltres, 10},
            {PokemonId.Dratini, 4},
            {PokemonId.Dragonair, 6},
            {PokemonId.Dragonite, 10},
            {PokemonId.Mewtwo, 10},
            {PokemonId.Mew, 10}
        };

        public static int HowRare(this PokemonId id)
        {
            return RareStatus.ContainsKey(id) ? RareStatus[id] : 1;
        }
    }
}