﻿#region using directives

using System;
using POGOProtos.Data;
using POGOProtos.Enums;
using System.Collections.Generic;

#endregion

namespace PoGo.PokeMobBot.Logic.PoGoUtils
{
    public class PokemonMoveSet
    {
        public PokemonId Pokemon { get; set; }
        public PokemonMove Move1 { get; set; }
        public PokemonMove Move2 { get; set; }
        public Dictionary<string, int> _RankVsType = new Dictionary<string, int>(){
        };
        public void SetRankVsType(string key, int value)
        {
          _RankVsType[key] = value;
        }
        public int GetRankVsType(string key)
        {
            if (_RankVsType.ContainsKey(key))
                return _RankVsType[key];
            else
                return 0;
        }

        public int[] RankVsTypes
        {
            get
            {
                return new int[] {
                   GetRankVsType(PokemonType.Normal.ToString()),
                    GetRankVsType(PokemonType.Fire.ToString()),
                    GetRankVsType(PokemonType.Water.ToString()),
                    GetRankVsType(PokemonType.Electric.ToString()),
                    GetRankVsType(PokemonType.Grass.ToString()),
                    GetRankVsType(PokemonType.Ice.ToString()),
                    GetRankVsType(PokemonType.Fighting.ToString()),
                    GetRankVsType(PokemonType.Poison.ToString()),
                    GetRankVsType(PokemonType.Ground.ToString()),
                    GetRankVsType(PokemonType.Flying.ToString()),
                    GetRankVsType(PokemonType.Psychic.ToString()),
                    GetRankVsType(PokemonType.Bug.ToString()),
                    GetRankVsType(PokemonType.Rock.ToString()),
                    GetRankVsType(PokemonType.Ghost.ToString()),
                    GetRankVsType(PokemonType.Dragon.ToString()),
                    GetRankVsType(PokemonType.Dark.ToString()),
                    GetRankVsType(PokemonType.Steel.ToString()),
                    GetRankVsType(PokemonType.Fairy.ToString()),
                    GetRankVsType(PokemonType.None.ToString()),
                    GetRankVsType("Average")
                };
            }
            set
            {
                SetRankVsType(PokemonType.Normal.ToString(), value[0]);
                SetRankVsType(PokemonType.Fire.ToString(), value[1]);
                SetRankVsType(PokemonType.Water.ToString(), value[2]);
                SetRankVsType(PokemonType.Electric.ToString(), value[3]);
                SetRankVsType(PokemonType.Grass.ToString(), value[4]);
                SetRankVsType(PokemonType.Ice.ToString(), value[5]);
                SetRankVsType(PokemonType.Fighting.ToString(), value[6]);
                SetRankVsType(PokemonType.Poison.ToString(), value[7]);
                SetRankVsType(PokemonType.Ground.ToString(), value[8]);
                SetRankVsType(PokemonType.Flying.ToString(), value[9]);
                SetRankVsType(PokemonType.Psychic.ToString(), value[10]);
                SetRankVsType(PokemonType.Bug.ToString(), value[11]);
                SetRankVsType(PokemonType.Rock.ToString(), value[12]);
                SetRankVsType(PokemonType.Ghost.ToString(), value[13]);
                SetRankVsType(PokemonType.Dragon.ToString(), value[14]);
                SetRankVsType(PokemonType.Dark.ToString(), value[15]);
                SetRankVsType(PokemonType.Steel.ToString(), value[16]);
                SetRankVsType(PokemonType.Fairy.ToString(), value[17]);
                SetRankVsType(PokemonType.None.ToString(), value[18]);
                SetRankVsType("Average", value[19]);
            }
            
            
        }
    }
    public class PokemonMoveInfo
    {

        public static int GetMoveSetCombinationIndex(PokemonId poke, PokemonMove move1, PokemonMove move2)
        {  
            return ((int)poke * 1000000) + ((int)move1 * 1000) + ((int)move2);
        }

        public static void SetPokemonMoveSet(int key, PokemonMoveSet value)
        {
            _PokemonMoveSets[key] = value;
        }
        public static PokemonMoveSet GetPokemonMoveSet(int key)
        {
            if (_PokemonMoveSets.ContainsKey(key))
                return _PokemonMoveSets[key];
            else
                return null;
        }


            private static Dictionary<int, PokemonMoveSet> _PokemonMoveSets = new Dictionary<int, PokemonMoveSet>()
        {
          {GetMoveSetCombinationIndex(PokemonId.Mewtwo,PokemonMove.PsychoCutFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Mewtwo, Move1=PokemonMove.PsychoCutFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {1,1,1,1,1,1,1,1,1,1,1,1,1,4,1,1,1,1,1,1}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Mewtwo,PokemonMove.PsychoCutFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Mewtwo, Move1=PokemonMove.PsychoCutFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {2,2,2,2,2,2,2,2,2,2,2,2,2,5,2,2,2,2,2,2}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Mewtwo,PokemonMove.PsychoCutFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Mewtwo, Move1=PokemonMove.PsychoCutFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {3,3,3,3,3,3,3,3,3,3,3,3,3,6,3,3,3,3,3,3}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Snorlax,PokemonMove.LickFast,PokemonMove.BodySlam), new PokemonMoveSet {Pokemon=PokemonId.Snorlax, Move1=PokemonMove.LickFast,Move2 = PokemonMove.BodySlam, RankVsTypes = new int[] {4,10,4,4,5,7,10,7,7,4,4,4,10,1,4,4,7,4,4,5}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Vaporeon,PokemonMove.WaterGunFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Vaporeon, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {5,4,8,15,67,4,11,11,4,10,10,14,4,8,15,5,4,8,7,11}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Vaporeon,PokemonMove.WaterGunFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Vaporeon, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {6,5,9,16,68,5,12,12,5,11,11,15,5,9,16,6,5,9,8,12}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Vaporeon,PokemonMove.WaterGunFast,PokemonMove.AquaTail), new PokemonMoveSet {Pokemon=PokemonId.Vaporeon, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.AquaTail, RankVsTypes = new int[] {7,6,10,17,69,6,13,13,6,12,12,16,6,10,17,7,6,10,9,13}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Snorlax,PokemonMove.LickFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Snorlax, Move1=PokemonMove.LickFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {19,27,6,8,17,11,34,9,18,8,5,12,17,2,8,16,14,5,5,13}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Snorlax,PokemonMove.LickFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Snorlax, Move1=PokemonMove.LickFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {20,28,7,9,18,12,35,10,19,9,6,13,18,3,9,17,15,6,6,14}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dragonite,PokemonMove.DragonBreathFast,PokemonMove.DragonClaw), new PokemonMoveSet {Pokemon=PokemonId.Dragonite, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.DragonClaw, RankVsTypes = new int[] {8,17,5,10,4,58,5,15,11,16,13,5,33,11,10,8,27,76,10,18}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Snorlax,PokemonMove.ZenHeadbuttFast,PokemonMove.BodySlam), new PokemonMoveSet {Pokemon=PokemonId.Snorlax, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.BodySlam, RankVsTypes = new int[] {9,29,11,11,24,19,26,8,23,17,26,20,22,7,14,15,31,13,11,18}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Slowbro,PokemonMove.WaterGunFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Slowbro, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {13,7,20,44,102,8,7,22,12,20,7,55,14,32,39,32,11,15,12,25}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Slowbro,PokemonMove.WaterGunFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Slowbro, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {14,8,21,45,103,9,8,23,13,21,8,56,15,33,40,33,12,16,13,26}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Slowbro,PokemonMove.WaterGunFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Slowbro, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {15,9,22,46,104,10,9,24,14,22,9,57,16,34,41,34,13,17,14,27}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lapras,PokemonMove.FrostBreathFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Lapras, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {16,59,23,47,26,13,80,25,15,5,23,24,44,14,5,12,44,21,15,27}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lapras,PokemonMove.FrostBreathFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Lapras, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {17,60,24,48,27,14,81,26,16,6,24,25,45,15,6,13,45,22,16,28}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lapras,PokemonMove.FrostBreathFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Lapras, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {18,61,25,49,28,15,82,27,17,7,25,26,46,16,7,14,46,23,17,29}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Blastoise,PokemonMove.WaterGunFast,PokemonMove.FlashCannon), new PokemonMoveSet {Pokemon=PokemonId.Blastoise, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.FlashCannon, RankVsTypes = new int[] {21,11,29,51,113,16,37,31,20,25,27,30,19,17,49,18,16,24,18,30}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Blastoise,PokemonMove.WaterGunFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Blastoise, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {22,12,30,52,114,17,38,32,21,26,28,31,20,18,50,19,17,25,19,31}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {24,38,26,18,32,27,6,16,30,28,15,67,38,49,18,62,52,27,21,31}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Blastoise,PokemonMove.WaterGunFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Blastoise, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {23,13,31,53,115,18,39,33,22,27,29,32,21,19,51,20,18,26,20,32}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Mewtwo,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Mewtwo, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {25,39,32,20,35,28,4,14,33,29,34,65,32,38,19,85,57,28,22,34}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Snorlax,PokemonMove.ZenHeadbuttFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Snorlax, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {32,41,35,24,47,34,60,17,38,33,48,41,39,12,23,39,61,40,29,36}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Snorlax,PokemonMove.ZenHeadbuttFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Snorlax, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {33,42,38,25,54,36,61,18,40,37,59,48,37,13,25,54,50,50,30,39}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Articuno,PokemonMove.FrostBreathFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Articuno, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {29,113,62,59,6,63,47,37,8,13,31,17,97,20,11,21,101,31,23,42}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Articuno,PokemonMove.FrostBreathFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Articuno, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {30,114,63,60,7,64,48,38,9,14,32,18,98,21,12,22,102,32,24,43}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Articuno,PokemonMove.FrostBreathFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Articuno, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {31,115,64,61,8,65,49,39,10,15,33,19,99,22,13,23,103,33,25,44}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.Hurricane), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Hurricane, RankVsTypes = new int[] {34,46,39,35,34,37,15,47,41,38,14,68,65,80,26,60,68,51,31,44}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golem,PokemonMove.MudShotFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Golem, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {10,18,115,5,193,59,98,4,70,23,35,63,7,23,20,24,28,37,26,45}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Dragonite,PokemonMove.DragonBreathFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Dragonite, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {35,33,15,29,13,130,24,50,24,39,38,21,69,26,27,27,73,156,32,45}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Poliwrath,PokemonMove.MudShotFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Poliwrath, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {37,21,17,32,154,20,63,19,45,125,66,52,11,28,30,9,8,87,34,45}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dragonite,PokemonMove.DragonBreathFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Dragonite, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {36,34,16,30,14,131,25,51,25,40,39,22,70,27,28,28,74,147,33,46}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Poliwrath,PokemonMove.MudShotFast,PokemonMove.Submission), new PokemonMoveSet {Pokemon=PokemonId.Poliwrath, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.Submission, RankVsTypes = new int[] {38,22,18,33,155,21,64,20,46,126,67,53,12,29,31,10,9,88,35,46}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Dragonite,PokemonMove.SteelWingFast,PokemonMove.DragonClaw), new PokemonMoveSet {Pokemon=PokemonId.Dragonite, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.DragonClaw, RankVsTypes = new int[] {47,45,37,58,20,89,33,58,29,47,40,23,47,31,44,30,82,78,44,46}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Poliwrath,PokemonMove.MudShotFast,PokemonMove.IcePunch), new PokemonMoveSet {Pokemon=PokemonId.Poliwrath, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.IcePunch, RankVsTypes = new int[] {39,23,19,34,156,22,65,21,47,127,68,54,13,30,32,11,10,89,36,47}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golem,PokemonMove.MudShotFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Golem, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {11,19,116,6,197,71,99,5,71,34,36,87,8,24,21,25,29,38,27,49}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {40,47,42,28,58,40,27,49,48,41,16,97,49,108,33,63,51,52,37,49}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Golem,PokemonMove.MudShotFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Golem, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {12,20,117,7,198,72,100,6,72,35,37,88,9,25,22,26,30,39,28,50}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {42,51,36,37,60,42,29,53,50,36,18,99,58,98,34,65,63,54,39,51}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.Moonblast), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Moonblast, RankVsTypes = new int[] {43,52,44,38,61,43,22,54,51,43,19,100,64,102,24,59,79,55,40,52}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {44,53,45,39,51,35,30,55,52,44,20,91,74,103,35,66,48,56,41,52}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Golduck,PokemonMove.WaterGunFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Golduck, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {48,24,48,72,167,23,76,62,26,48,45,60,23,35,75,35,22,60,45,52}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {41,50,43,36,59,41,28,52,49,42,17,98,73,110,29,64,78,53,38,53}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Golduck,PokemonMove.WaterGunFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Golduck, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {49,25,49,73,168,24,77,63,27,49,46,61,24,36,76,36,23,61,46,53}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {45,54,41,40,62,44,31,56,44,45,21,101,52,112,36,67,80,57,42,54}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Golduck,PokemonMove.WaterGunFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Golduck, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {50,26,50,74,169,25,78,64,28,50,47,62,25,37,77,37,24,62,47,54}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Mew,PokemonMove.PoundFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Mew, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {46,55,46,41,63,45,32,57,53,46,22,102,75,113,37,68,81,58,43,57}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Muk,PokemonMove.PoisonJabFast,PokemonMove.GunkShot), new PokemonMoveSet {Pokemon=PokemonId.Muk, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.GunkShot, RankVsTypes = new int[] {51,62,53,50,19,51,36,66,139,52,79,29,86,75,45,38,89,7,48,57}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Muk,PokemonMove.PoisonJabFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Muk, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {54,66,57,56,21,56,43,74,146,55,83,33,94,83,53,41,94,11,51,62}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Charizard,PokemonMove.WingAttackFast,PokemonMove.DragonClaw), new PokemonMoveSet {Pokemon=PokemonId.Charizard, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.DragonClaw, RankVsTypes = new int[] {58,40,104,130,11,66,19,80,68,61,56,8,186,43,42,46,60,46,59,62}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Exeggutor,PokemonMove.ZenHeadbuttFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Exeggutor, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {52,103,27,19,33,92,14,65,31,79,49,163,48,76,46,138,91,67,49,65}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Omastar,PokemonMove.WaterGunFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Omastar, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {26,14,98,86,255,29,131,34,60,30,51,72,29,39,91,42,54,70,52,66}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Mewtwo,PokemonMove.ConfusionFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Mewtwo, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {53,65,56,55,75,55,21,42,63,54,44,119,63,101,52,115,93,69,50,66}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Omastar,PokemonMove.WaterGunFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Omastar, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {27,15,99,87,256,30,132,35,61,31,52,73,30,40,92,43,55,71,53,67}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Muk,PokemonMove.PoisonJabFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Muk, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {57,70,61,63,22,61,50,76,155,60,88,37,100,90,60,45,105,12,58,67}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Mewtwo,PokemonMove.ConfusionFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Mewtwo, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {70,69,60,62,77,60,23,48,67,59,30,124,53,59,59,154,75,75,57,67}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Omastar,PokemonMove.WaterGunFast,PokemonMove.RockSlide), new PokemonMoveSet {Pokemon=PokemonId.Omastar, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.RockSlide, RankVsTypes = new int[] {28,16,100,88,257,31,133,36,62,32,53,74,31,41,93,44,56,72,54,68}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Venusaur,PokemonMove.VineWhipFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Venusaur, Move1=PokemonMove.VineWhipFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {59,143,12,23,23,108,51,118,35,131,93,108,34,46,72,47,107,18,60,68}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Moltres,PokemonMove.EmberFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Moltres, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {60,75,164,96,9,33,55,82,69,62,57,6,201,44,101,50,19,43,61,68}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Charizard,PokemonMove.WingAttackFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Charizard, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {67,44,121,139,12,53,20,89,75,66,62,9,220,52,64,58,34,47,67,68}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Zapdos,PokemonMove.ThunderShockFast,PokemonMove.Thunderbolt), new PokemonMoveSet {Pokemon=PokemonId.Zapdos, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunderbolt, RankVsTypes = new int[] {61,73,34,102,89,111,57,84,107,18,58,42,103,45,102,51,32,79,62,69}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Dragonite,PokemonMove.SteelWingFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Dragonite, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {64,64,55,76,25,154,62,87,39,64,60,45,80,50,73,55,113,105,65,70}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Charizard,PokemonMove.WingAttackFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Charizard, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {66,43,120,158,10,73,18,88,74,65,61,7,219,51,63,57,49,45,66,70}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Exeggutor,PokemonMove.ZenHeadbuttFast,PokemonMove.SeedBomb), new PokemonMoveSet {Pokemon=PokemonId.Exeggutor, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.SeedBomb, RankVsTypes = new int[] {55,110,33,21,37,101,16,72,34,90,54,171,51,84,54,148,97,73,55,71}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Exeggutor,PokemonMove.ZenHeadbuttFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Exeggutor, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {56,111,28,22,38,102,17,73,32,91,50,172,50,85,55,141,98,74,56,71}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arcanine,PokemonMove.BiteFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Arcanine, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {71,71,157,69,30,26,117,91,111,69,55,28,147,42,94,79,25,64,68,74}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Zapdos,PokemonMove.ThunderShockFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Zapdos, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {73,86,40,116,97,129,66,93,120,19,65,50,116,62,122,61,35,85,69,79}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Venusaur,PokemonMove.VineWhipFast,PokemonMove.PetalBlizzard), new PokemonMoveSet {Pokemon=PokemonId.Venusaur, Move1=PokemonMove.VineWhipFast,Move2 = PokemonMove.PetalBlizzard, RankVsTypes = new int[] {62,178,13,26,48,121,53,122,36,177,99,133,35,47,104,52,111,41,63,80}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Venusaur,PokemonMove.VineWhipFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Venusaur, Move1=PokemonMove.VineWhipFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {63,179,14,27,49,122,54,123,37,178,100,134,36,48,105,53,112,42,64,81}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Moltres,PokemonMove.EmberFast,PokemonMove.HeatWave), new PokemonMoveSet {Pokemon=PokemonId.Moltres, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.HeatWave, RankVsTypes = new int[] {75,93,189,115,15,39,69,95,82,71,69,10,234,63,125,70,20,59,71,82}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Nidoqueen,PokemonMove.PoisonJabFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Nidoqueen, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {76,74,135,43,65,120,75,46,187,63,121,43,59,99,71,73,125,20,72,82}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Nidoqueen,PokemonMove.PoisonJabFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Nidoqueen, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {80,83,139,31,64,149,74,40,178,75,125,59,54,109,74,75,99,19,76,84}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Nidoqueen,PokemonMove.PoisonJabFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Nidoqueen, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {74,87,132,42,57,140,67,60,180,70,118,51,76,114,67,69,123,14,70,85}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Starmie,PokemonMove.WaterGunFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Starmie, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {77,35,81,121,220,46,70,96,54,72,41,145,41,115,128,117,36,90,73,87}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Moltres,PokemonMove.EmberFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Moltres, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {81,95,197,125,16,49,79,99,83,76,71,11,242,66,134,76,21,63,77,87}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Starmie,PokemonMove.WaterGunFast,PokemonMove.PowerGem), new PokemonMoveSet {Pokemon=PokemonId.Starmie, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.PowerGem, RankVsTypes = new int[] {78,36,82,122,221,47,71,97,55,73,42,146,42,116,129,118,37,91,74,88}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Starmie,PokemonMove.WaterGunFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.Starmie, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {79,37,83,123,222,48,72,98,56,74,43,147,43,117,130,119,38,92,75,89}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dragonite,PokemonMove.SteelWingFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Dragonite, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {82,84,71,110,31,171,84,100,58,77,74,64,87,78,135,78,131,106,78,89}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Arcanine,PokemonMove.BiteFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Arcanine, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {88,85,184,79,55,38,148,103,144,81,63,49,176,60,119,113,33,82,84,94}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Lapras,PokemonMove.IceShardFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Lapras, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {83,149,89,128,105,57,158,101,57,51,75,115,129,69,43,80,134,98,79,95}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Sandslash,PokemonMove.MudShotFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Sandslash, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {84,56,143,12,240,165,120,28,88,148,76,158,26,70,83,81,41,99,80,95}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Zapdos,PokemonMove.ThunderShockFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Zapdos, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {87,101,52,134,110,164,86,102,141,24,80,66,134,74,140,84,47,102,83,95}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Gyarados,PokemonMove.DragonBreathFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Gyarados, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {93,48,75,191,149,96,89,106,42,86,84,70,112,82,78,88,72,152,89,95}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Sandslash,PokemonMove.MudShotFast,PokemonMove.RockTomb), new PokemonMoveSet {Pokemon=PokemonId.Sandslash, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.RockTomb, RankVsTypes = new int[] {85,57,144,13,241,166,121,29,89,149,77,159,27,71,84,82,42,100,81,96}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Sandslash,PokemonMove.MudShotFast,PokemonMove.Bulldoze), new PokemonMoveSet {Pokemon=PokemonId.Sandslash, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.Bulldoze, RankVsTypes = new int[] {86,58,145,14,242,167,122,30,90,150,78,160,28,72,85,83,43,101,82,97}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Gyarados,PokemonMove.BiteFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Gyarados, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {94,49,76,192,150,97,109,107,43,87,64,71,113,61,121,114,53,153,90,97}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lapras,PokemonMove.IceShardFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Lapras, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {89,156,101,133,108,70,164,104,59,53,82,120,137,81,47,87,140,109,85,101}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Muk,PokemonMove.AcidFast,PokemonMove.GunkShot), new PokemonMoveSet {Pokemon=PokemonId.Muk, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.GunkShot, RankVsTypes = new int[] {95,109,96,85,42,99,91,111,207,88,132,76,145,138,89,89,148,30,91,103}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Alakazam,PokemonMove.PsychoCutFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Alakazam, Move1=PokemonMove.PsychoCutFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {90,106,93,82,116,93,40,68,97,83,85,165,91,132,86,210,143,111,86,104}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Arcanine,PokemonMove.FireFangFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Arcanine, Move1=PokemonMove.FireFangFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {100,126,217,94,44,32,137,115,153,93,92,39,202,89,154,98,26,77,96,104}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Alakazam,PokemonMove.PsychoCutFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Alakazam, Move1=PokemonMove.PsychoCutFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {91,107,94,83,117,94,41,69,98,84,86,166,92,133,87,211,144,112,87,105}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Alakazam,PokemonMove.PsychoCutFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Alakazam, Move1=PokemonMove.PsychoCutFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {92,108,95,84,118,95,42,70,99,85,87,167,93,134,88,212,145,113,88,106}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Nidoking,PokemonMove.PoisonJabFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Nidoking, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {96,112,152,57,76,179,90,75,212,92,133,75,95,142,90,91,150,29,92,107}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Kabutops,PokemonMove.MudShotFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Kabutops, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {65,30,119,109,288,52,188,45,171,68,102,137,62,96,103,103,66,137,106,108}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Nidoking,PokemonMove.PoisonJabFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Nidoking, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {102,105,162,54,84,186,95,61,208,95,144,84,77,135,97,101,122,34,98,108}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dewgong,PokemonMove.FrostBreathFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Dewgong, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {97,166,106,143,123,67,173,112,64,56,89,126,148,86,56,95,154,122,93,109}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Wigglytuff,PokemonMove.PoundFast,PokemonMove.PlayRough), new PokemonMoveSet {Pokemon=PokemonId.Wigglytuff, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.PlayRough, RankVsTypes = new int[] {107,121,111,100,133,114,111,164,105,99,98,83,126,65,38,31,222,131,103,109}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dewgong,PokemonMove.FrostBreathFast,PokemonMove.AquaJet), new PokemonMoveSet {Pokemon=PokemonId.Dewgong, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.AquaJet, RankVsTypes = new int[] {98,167,107,144,124,68,174,113,65,57,90,127,149,87,57,96,155,123,94,110}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Dewgong,PokemonMove.FrostBreathFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Dewgong, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {99,168,108,145,125,69,175,114,66,58,91,128,150,88,58,97,156,124,95,111}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Muk,PokemonMove.AcidFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Muk, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {101,116,105,97,45,109,97,120,216,94,136,86,158,150,96,100,157,36,97,111}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Tentacruel,PokemonMove.PoisonJabFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Tentacruel, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {118,68,69,163,90,77,107,116,189,113,157,93,130,144,111,107,104,48,113,111}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Nidoking,PokemonMove.PoisonJabFast,PokemonMove.Megahorn), new PokemonMoveSet {Pokemon=PokemonId.Nidoking, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.Megahorn, RankVsTypes = new int[] {103,118,163,64,85,187,96,83,217,96,137,85,101,151,98,93,158,35,99,114}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Wigglytuff,PokemonMove.PoundFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Wigglytuff, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {105,119,109,98,131,112,139,162,103,97,96,81,164,93,61,48,220,129,101,114}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Tentacruel,PokemonMove.PoisonJabFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Tentacruel, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {111,76,65,154,86,75,101,124,230,103,148,90,169,157,106,104,114,44,107,114}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Wigglytuff,PokemonMove.PoundFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Wigglytuff, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {106,120,110,99,132,113,140,163,104,98,97,82,165,94,62,49,221,130,102,115}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Tentacruel,PokemonMove.PoisonJabFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Tentacruel, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {119,79,70,164,91,78,108,132,215,114,158,94,173,167,112,108,116,49,114,119}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kabutops,PokemonMove.MudShotFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Kabutops, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {68,31,127,107,323,79,186,43,169,119,113,203,60,104,115,111,64,145,117,120}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Nidoqueen,PokemonMove.BiteFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Nidoqueen, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {116,132,178,68,107,196,123,67,204,108,130,92,88,97,109,132,135,80,111,120}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Nidoqueen,PokemonMove.BiteFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Nidoqueen, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {124,104,182,70,147,170,154,59,206,80,131,69,71,79,118,143,138,114,122,120}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Kabutops,PokemonMove.MudShotFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Kabutops, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {69,32,128,108,324,80,187,44,170,120,114,204,61,105,116,112,65,146,118,121}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Hypno,PokemonMove.ZenHeadbuttFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Hypno, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {108,125,114,101,135,119,52,81,106,101,101,179,105,152,100,227,163,135,104,121}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Blastoise,PokemonMove.BiteFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Blastoise, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {123,63,91,165,245,83,166,131,93,118,81,139,85,77,144,134,71,173,120,121}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Exeggutor,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Exeggutor, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {104,157,67,66,88,177,56,105,73,158,103,232,102,137,99,215,159,128,100,122}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venusaur,PokemonMove.RazorLeafFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Venusaur, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {109,197,51,67,56,185,102,168,100,205,142,152,96,122,136,102,164,65,105,122}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Pidgeot,PokemonMove.WingAttackFast,PokemonMove.Hurricane), new PokemonMoveSet {Pokemon=PokemonId.Pidgeot, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.Hurricane, RankVsTypes = new int[] {117,134,124,218,50,197,103,126,76,111,110,44,227,56,110,106,177,142,112,123}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Lapras,PokemonMove.IceShardFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Lapras, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {115,148,88,156,183,54,179,125,92,78,104,136,168,100,65,105,172,172,110,124}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Clefable,PokemonMove.PoundFast,PokemonMove.Moonblast), new PokemonMoveSet {Pokemon=PokemonId.Clefable, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Moonblast, RankVsTypes = new int[] {122,142,129,111,143,128,87,197,112,117,115,95,141,129,48,40,237,151,119,124}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Pidgeot,PokemonMove.WingAttackFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Pidgeot, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {120,135,125,222,52,198,104,128,77,115,111,46,228,57,113,109,179,143,115,125}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Pidgeot,PokemonMove.WingAttackFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Pidgeot, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {121,136,126,223,53,199,105,129,78,116,112,47,229,58,114,110,180,144,116,126}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Charizard,PokemonMove.EmberFast,PokemonMove.DragonClaw), new PokemonMoveSet {Pokemon=PokemonId.Charizard, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.DragonClaw, RankVsTypes = new int[] {130,127,215,174,43,100,115,140,126,132,122,38,260,118,124,120,67,120,127,126}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Hypno,PokemonMove.ZenHeadbuttFast,PokemonMove.Psyshock), new PokemonMoveSet {Pokemon=PokemonId.Hypno, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psyshock, RankVsTypes = new int[] {112,130,122,103,137,125,58,85,109,105,105,189,107,158,107,244,168,139,108,127}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hypno,PokemonMove.ZenHeadbuttFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Hypno, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {113,131,123,104,138,126,59,86,110,106,106,190,108,159,108,245,169,140,109,128}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Clefable,PokemonMove.PoundFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Clefable, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {128,140,133,119,157,141,88,156,123,128,120,105,144,136,68,72,246,160,125,131}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Arcanine,PokemonMove.FireFangFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Arcanine, Move1=PokemonMove.FireFangFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {133,145,248,126,66,50,156,142,182,134,123,58,244,119,186,121,39,96,129,131}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Slowbro,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Slowbro, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {125,91,80,162,207,86,68,92,119,122,124,195,121,161,120,247,126,154,123,133}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Arcanine,PokemonMove.BiteFast,PokemonMove.Bulldoze), new PokemonMoveSet {Pokemon=PokemonId.Arcanine, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.Bulldoze, RankVsTypes = new int[] {132,92,192,124,101,87,209,141,186,133,70,107,179,64,127,195,86,166,128,133}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Charizard,PokemonMove.EmberFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Charizard, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {135,147,252,182,29,88,116,143,133,138,126,27,309,120,192,123,40,97,130,133}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Machamp,PokemonMove.KarateChopFast,PokemonMove.CrossChop), new PokemonMoveSet {Pokemon=PokemonId.Machamp, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.CrossChop, RankVsTypes = new int[] {72,138,130,113,146,81,150,184,117,249,243,144,40,179,117,29,69,267,121,136}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Clefable,PokemonMove.ZenHeadbuttFast,PokemonMove.Moonblast), new PokemonMoveSet {Pokemon=PokemonId.Clefable, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Moonblast, RankVsTypes = new int[] {136,151,140,127,165,151,73,152,134,139,154,109,128,121,66,90,252,167,131,136}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Nidoqueen,PokemonMove.BiteFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Nidoqueen, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {137,117,201,65,199,219,143,41,196,175,146,132,56,95,137,159,106,136,132,136}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Gyarados,PokemonMove.BiteFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Gyarados, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {142,99,87,259,175,161,142,148,87,144,73,114,192,68,95,156,88,223,137,136}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Gyarados,PokemonMove.DragonBreathFast,PokemonMove.Twister), new PokemonMoveSet {Pokemon=PokemonId.Gyarados, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.Twister, RankVsTypes = new int[] {139,96,84,256,172,158,118,145,84,141,127,111,189,124,79,125,132,220,134,139}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Clefable,PokemonMove.PoundFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Clefable, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {129,141,134,120,158,142,112,196,124,129,119,106,180,192,69,71,247,161,126,140}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Gyarados,PokemonMove.DragonBreathFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Gyarados, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {140,97,85,257,173,159,119,146,85,142,128,112,190,125,80,126,133,221,135,140}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Gyarados,PokemonMove.BiteFast,PokemonMove.Twister), new PokemonMoveSet {Pokemon=PokemonId.Gyarados, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.Twister, RankVsTypes = new int[] {141,98,86,258,174,160,163,147,86,143,72,113,191,67,139,202,87,222,136,141}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venusaur,PokemonMove.RazorLeafFast,PokemonMove.PetalBlizzard), new PokemonMoveSet {Pokemon=PokemonId.Venusaur, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.PetalBlizzard, RankVsTypes = new int[] {126,244,47,71,106,209,113,195,81,256,172,216,72,111,175,116,186,93,124,143}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Clefable,PokemonMove.ZenHeadbuttFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Clefable, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {138,146,141,131,171,157,83,144,135,140,195,110,131,123,82,130,261,168,133,143}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Muk,PokemonMove.AcidFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Muk, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {150,153,148,136,70,172,129,135,240,154,160,118,174,126,142,136,182,66,143,144}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Clefable,PokemonMove.ZenHeadbuttFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Clefable, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {146,150,146,135,186,169,85,151,142,153,193,116,139,127,81,99,266,170,139,147}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Blastoise,PokemonMove.BiteFast,PokemonMove.FlashCannon), new PokemonMoveSet {Pokemon=PokemonId.Blastoise, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.FlashCannon, RankVsTypes = new int[] {166,122,112,208,259,76,185,160,157,170,94,176,110,91,153,171,108,158,159,149}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Victreebel,PokemonMove.RazorLeafFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Victreebel, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {143,219,68,77,74,216,125,210,136,228,187,180,132,160,156,129,196,81,138,150}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Gengar,PokemonMove.ShadowClawFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Gengar, Move1=PokemonMove.ShadowClawFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {153,165,161,149,112,184,94,79,223,168,140,80,156,147,152,290,153,108,157,151}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Gengar,PokemonMove.ShadowClawFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Gengar, Move1=PokemonMove.ShadowClawFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {167,163,159,147,129,182,92,77,221,166,138,78,154,145,150,305,151,125,155,153}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Blastoise,PokemonMove.BiteFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Blastoise, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {170,123,113,209,219,115,207,165,125,130,95,178,159,92,126,194,109,210,161,153}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golbat,PokemonMove.WingAttackFast,PokemonMove.PoisonFang), new PokemonMoveSet {Pokemon=PokemonId.Golbat, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.PoisonFang, RankVsTypes = new int[] {160,158,153,283,39,236,44,108,148,161,211,34,274,139,146,145,213,117,149,154}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Flareon,PokemonMove.EmberFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Flareon, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {164,169,275,142,81,62,172,158,211,165,135,77,269,143,206,150,58,127,154,154}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Gengar,PokemonMove.ShadowClawFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Gengar, Move1=PokemonMove.ShadowClawFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {168,164,160,148,130,183,93,78,222,167,139,79,155,146,151,306,152,126,156,154}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Golbat,PokemonMove.WingAttackFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Golbat, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {161,159,154,284,40,237,45,109,149,162,212,35,275,140,147,146,214,118,150,155}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Golbat,PokemonMove.WingAttackFast,PokemonMove.OminousWind), new PokemonMoveSet {Pokemon=PokemonId.Golbat, Move1=PokemonMove.WingAttackFast,Move2 = PokemonMove.OminousWind, RankVsTypes = new int[] {162,160,155,285,41,238,46,110,150,163,213,36,276,141,148,147,215,119,151,156}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Charizard,PokemonMove.EmberFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Charizard, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {165,172,278,201,46,107,141,159,156,169,143,40,341,149,212,155,59,132,158,157}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Victreebel,PokemonMove.AcidFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Victreebel, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {149,208,92,81,36,223,130,216,205,216,197,162,195,205,141,135,203,68,142,158}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venusaur,PokemonMove.RazorLeafFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Venusaur, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {147,272,54,78,119,225,128,215,91,276,199,235,84,128,198,133,200,107,140,159}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Nidoking,PokemonMove.FuryCutterFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Nidoking, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {158,174,211,91,121,233,146,117,259,173,192,123,136,215,145,128,210,83,147,161}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arcanine,PokemonMove.FireFangFast,PokemonMove.Bulldoze), new PokemonMoveSet {Pokemon=PokemonId.Arcanine, Move1=PokemonMove.FireFangFast,Move2 = PokemonMove.Bulldoze, RankVsTypes = new int[] {173,155,291,157,87,74,180,170,229,179,150,89,261,155,225,165,62,138,166,163}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Machamp,PokemonMove.BulletPunchFast,PokemonMove.CrossChop), new PokemonMoveSet {Pokemon=PokemonId.Machamp, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.CrossChop, RankVsTypes = new int[] {127,196,191,181,192,103,171,188,151,247,241,150,55,182,149,77,141,227,152,164}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Victreebel,PokemonMove.RazorLeafFast,PokemonMove.LeafBlade), new PokemonMoveSet {Pokemon=PokemonId.Victreebel, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.LeafBlade, RankVsTypes = new int[] {152,275,58,89,128,227,134,220,94,279,200,239,89,130,203,139,204,115,144,164}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Wigglytuff,PokemonMove.FeintAttackFast,PokemonMove.PlayRough), new PokemonMoveSet {Pokemon=PokemonId.Wigglytuff, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.PlayRough, RankVsTypes = new int[] {171,207,166,153,196,188,161,294,158,172,129,131,160,73,70,86,264,202,162,165}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Vileplume,PokemonMove.RazorLeafFast,PokemonMove.PetalBlizzard), new PokemonMoveSet {Pokemon=PokemonId.Vileplume, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.PetalBlizzard, RankVsTypes = new int[] {155,278,59,90,127,229,135,226,96,282,203,243,90,131,205,142,205,116,145,166}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Exeggutor,PokemonMove.ConfusionFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Exeggutor, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {148,228,72,80,139,221,106,206,79,242,116,322,111,200,163,228,201,171,141,167}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Victreebel,PokemonMove.AcidFast,PokemonMove.LeafBlade), new PokemonMoveSet {Pokemon=PokemonId.Victreebel, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.LeafBlade, RankVsTypes = new int[] {159,256,77,93,82,232,136,233,137,263,207,218,133,173,183,144,212,95,148,167}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Machamp,PokemonMove.KarateChopFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Machamp, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {131,144,165,152,195,110,208,208,190,225,258,130,78,197,155,74,146,278,160,169}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Vileplume,PokemonMove.AcidFast,PokemonMove.PetalBlizzard), new PokemonMoveSet {Pokemon=PokemonId.Vileplume, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.PetalBlizzard, RankVsTypes = new int[] {163,257,79,95,71,234,138,235,138,264,209,217,138,178,182,149,217,94,153,169}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Golem,PokemonMove.RockThrowFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Golem, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {114,77,269,106,296,181,318,90,279,67,147,129,109,153,157,162,276,186,163,173}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Flareon,PokemonMove.EmberFast,PokemonMove.HeatWave), new PokemonMoveSet {Pokemon=PokemonId.Flareon, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.HeatWave, RankVsTypes = new int[] {180,193,296,170,92,82,189,179,236,189,163,96,296,169,233,173,70,155,173,175}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Exeggutor,PokemonMove.ConfusionFast,PokemonMove.SeedBomb), new PokemonMoveSet {Pokemon=PokemonId.Exeggutor, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.SeedBomb, RankVsTypes = new int[] {157,254,73,92,164,231,110,205,80,261,117,337,114,209,176,240,208,175,146,176}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Tentacruel,PokemonMove.AcidFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Tentacruel, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {181,139,131,216,142,137,151,186,292,190,238,140,232,248,168,174,184,84,174,179}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Seadra,PokemonMove.WaterGunFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Seadra, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {188,80,185,228,327,132,194,181,113,195,169,209,117,175,238,181,117,197,181,179}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Seadra,PokemonMove.WaterGunFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Seadra, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {189,81,186,229,328,133,195,182,114,196,170,210,118,176,239,182,118,198,182,180}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Machamp,PokemonMove.KarateChopFast,PokemonMove.Submission), new PokemonMoveSet {Pokemon=PokemonId.Machamp, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.Submission, RankVsTypes = new int[] {110,180,173,155,203,123,178,257,162,305,309,199,57,239,158,56,110,310,164,181}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Seadra,PokemonMove.WaterGunFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Seadra, Move1=PokemonMove.WaterGunFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {190,82,187,230,329,134,196,183,115,197,171,211,119,177,240,183,119,199,183,181}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Sandslash,PokemonMove.MetalClawFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Sandslash, Move1=PokemonMove.MetalClawFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {182,210,294,137,271,204,190,127,174,191,164,205,66,170,169,175,202,148,175,182}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Nidoking,PokemonMove.FuryCutterFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Nidoking, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {195,152,238,75,253,266,162,71,245,258,230,196,83,199,173,163,136,169,186,182}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Lickitung,PokemonMove.LickFast,PokemonMove.PowerWhip), new PokemonMoveSet {Pokemon=PokemonId.Lickitung, Move1=PokemonMove.LickFast,Move2 = PokemonMove.PowerWhip, RankVsTypes = new int[] {250,187,172,168,212,203,259,178,161,188,109,202,167,55,167,237,176,193,172,182}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Lickitung,PokemonMove.LickFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Lickitung, Move1=PokemonMove.LickFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {261,185,179,166,210,201,257,176,172,186,107,200,170,53,165,252,174,191,170,183}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Persian,PokemonMove.ScratchFast,PokemonMove.NightSlash), new PokemonMoveSet {Pokemon=PokemonId.Persian, Move1=PokemonMove.ScratchFast,Move2 = PokemonMove.NightSlash, RankVsTypes = new int[] {176,182,175,159,204,193,251,173,164,181,151,192,221,163,159,166,232,187,167,184}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Ninetales,PokemonMove.EmberFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Ninetales, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {194,199,305,175,96,85,197,187,241,200,173,104,302,181,244,185,77,163,185,184}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Tentacruel,PokemonMove.AcidFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Tentacruel, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {200,124,151,236,194,148,157,166,249,204,253,149,184,224,202,187,162,110,190,184}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Kingler,PokemonMove.MudShotFast,PokemonMove.ViceGrip), new PokemonMoveSet {Pokemon=PokemonId.Kingler, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.ViceGrip, RankVsTypes = new int[] {202,88,136,178,339,144,201,137,183,267,181,284,123,189,178,191,83,207,191,184}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lickitung,PokemonMove.LickFast,PokemonMove.Stomp), new PokemonMoveSet {Pokemon=PokemonId.Lickitung, Move1=PokemonMove.LickFast,Move2 = PokemonMove.Stomp, RankVsTypes = new int[] {262,186,180,167,211,202,258,177,173,187,108,201,171,54,166,253,175,192,171,184}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Persian,PokemonMove.ScratchFast,PokemonMove.PowerGem), new PokemonMoveSet {Pokemon=PokemonId.Persian, Move1=PokemonMove.ScratchFast,Move2 = PokemonMove.PowerGem, RankVsTypes = new int[] {177,183,176,160,205,194,252,174,165,182,152,193,222,164,160,167,233,188,168,185}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Slowbro,PokemonMove.ConfusionFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Slowbro, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {187,154,150,224,239,174,127,155,143,155,134,269,175,246,143,284,185,196,180,185}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Flareon,PokemonMove.EmberFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Flareon, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {196,198,312,176,95,84,198,189,244,201,177,103,306,185,246,186,76,162,187,185}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Kingler,PokemonMove.MudShotFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Kingler, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {203,89,137,179,340,145,202,138,184,268,182,285,124,190,179,192,84,208,192,185}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Vileplume,PokemonMove.RazorLeafFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Vileplume, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {172,305,66,105,140,250,147,258,108,308,229,260,106,154,224,164,231,141,165,186}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Persian,PokemonMove.ScratchFast,PokemonMove.PlayRough), new PokemonMoveSet {Pokemon=PokemonId.Persian, Move1=PokemonMove.ScratchFast,Move2 = PokemonMove.PlayRough, RankVsTypes = new int[] {178,184,177,161,206,195,253,175,166,183,153,194,223,165,161,168,234,189,169,186}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Kingler,PokemonMove.MudShotFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Kingler, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {204,90,138,180,341,146,203,139,185,269,183,286,125,191,180,193,85,209,193,186}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Ninetales,PokemonMove.FeintAttackFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Ninetales, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {205,171,277,183,126,106,229,199,247,207,141,125,277,148,211,214,100,178,195,186}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Weezing,PokemonMove.AcidFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Weezing, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {185,189,183,171,93,207,153,193,291,194,237,143,235,249,172,179,240,86,178,188}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Sandslash,PokemonMove.MetalClawFast,PokemonMove.RockTomb), new PokemonMoveSet {Pokemon=PokemonId.Sandslash, Move1=PokemonMove.MetalClawFast,Move2 = PokemonMove.RockTomb, RankVsTypes = new int[] {183,240,303,172,272,205,191,133,175,192,165,206,67,171,170,176,238,149,176,189}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Sandslash,PokemonMove.MetalClawFast,PokemonMove.Bulldoze), new PokemonMoveSet {Pokemon=PokemonId.Sandslash, Move1=PokemonMove.MetalClawFast,Move2 = PokemonMove.Bulldoze, RankVsTypes = new int[] {184,241,304,173,273,206,192,134,176,193,166,207,68,172,171,177,239,150,177,190}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Kabutops,PokemonMove.FuryCutterFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Kabutops, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {134,67,193,239,314,90,340,153,290,89,156,157,181,203,184,170,250,228,196,191}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Poliwrath,PokemonMove.BubbleFast,PokemonMove.Submission), new PokemonMoveSet {Pokemon=PokemonId.Poliwrath, Move1=PokemonMove.BubbleFast,Move2 = PokemonMove.Submission, RankVsTypes = new int[] {151,128,156,231,286,105,204,247,159,295,301,186,79,230,201,92,96,307,194,192}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Vileplume,PokemonMove.AcidFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Vileplume, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {186,274,97,114,72,259,152,268,177,278,246,233,177,211,197,180,241,103,179,192}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Poliwrath,PokemonMove.BubbleFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Poliwrath, Move1=PokemonMove.BubbleFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {206,94,209,235,334,162,211,201,127,255,252,154,82,193,255,127,129,271,198,194}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Vileplume,PokemonMove.RazorLeafFast,PokemonMove.Moonblast), new PokemonMoveSet {Pokemon=PokemonId.Vileplume, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.Moonblast, RankVsTypes = new int[] {197,314,78,118,136,271,144,277,121,296,254,253,122,186,196,160,244,159,188,195}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Cloyster,PokemonMove.FrostBreathFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Cloyster, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {210,216,203,248,225,135,284,203,131,136,185,223,225,195,132,199,236,214,202,200}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Victreebel,PokemonMove.RazorLeafFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Victreebel, Move1=PokemonMove.RazorLeafFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {192,311,74,117,163,265,155,273,118,313,248,277,120,180,242,184,242,157,184,201}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Machamp,PokemonMove.BulletPunchFast,PokemonMove.Submission), new PokemonMoveSet {Pokemon=PokemonId.Machamp, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.Submission, RankVsTypes = new int[] {156,217,214,196,223,147,210,256,191,299,302,188,81,234,185,94,167,285,197,202}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hypno,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Hypno, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {198,194,190,177,218,210,114,136,181,202,191,268,178,245,174,325,245,206,189,202}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Machamp,PokemonMove.BulletPunchFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Machamp, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {212,202,224,211,232,150,235,209,224,227,256,135,104,198,191,131,258,241,204,202}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Wigglytuff,PokemonMove.FeintAttackFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Wigglytuff, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {213,204,200,188,233,218,236,280,195,213,145,153,212,107,138,161,287,250,205,202}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Weezing,PokemonMove.TackleFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Weezing, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {207,203,198,187,134,215,160,169,280,209,257,155,251,264,187,196,253,133,199,203}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Ninetales,PokemonMove.EmberFast,PokemonMove.HeatWave), new PokemonMoveSet {Pokemon=PokemonId.Ninetales, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.HeatWave, RankVsTypes = new int[] {218,214,338,190,111,91,217,213,261,218,201,117,327,204,269,205,90,174,210,204}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golem,PokemonMove.RockThrowFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Golem, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {145,100,317,112,367,240,323,94,285,110,196,198,115,201,193,203,259,224,207,205}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Cloyster,PokemonMove.FrostBreathFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Cloyster, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {209,263,202,247,224,155,283,202,130,135,184,222,248,194,131,198,256,213,201,205}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Slowbro,PokemonMove.ConfusionFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Slowbro, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {219,129,149,272,294,173,126,154,160,219,149,310,166,279,199,308,166,233,211,206}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Victreebel,PokemonMove.AcidFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Victreebel, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {208,293,118,129,83,282,159,283,188,294,259,247,182,225,210,197,255,121,200,207}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Cloyster,PokemonMove.FrostBreathFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Cloyster, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {211,264,204,249,226,156,285,204,132,137,186,224,249,196,133,200,257,215,203,207}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Vileplume,PokemonMove.AcidFast,PokemonMove.Moonblast), new PokemonMoveSet {Pokemon=PokemonId.Vileplume, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.Moonblast, RankVsTypes = new int[] {214,276,142,132,73,291,149,290,235,271,268,226,226,242,164,169,262,104,206,207}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Aerodactyl,PokemonMove.BiteFast,PokemonMove.IronHead), new PokemonMoveSet {Pokemon=PokemonId.Aerodactyl, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.IronHead, RankVsTypes = new int[] {144,190,299,310,237,235,233,150,198,151,162,161,198,168,194,216,304,190,208,208}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Ninetales,PokemonMove.EmberFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Ninetales, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {223,218,345,193,120,98,222,222,268,222,208,121,335,210,279,208,92,176,215,209}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Ninetales,PokemonMove.FeintAttackFast,PokemonMove.HeatWave), new PokemonMoveSet {Pokemon=PokemonId.Ninetales, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.HeatWave, RankVsTypes = new int[] {224,188,292,194,162,143,274,223,267,223,155,148,292,162,227,261,124,211,216,210}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Tentacruel,PokemonMove.AcidFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Tentacruel, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {225,173,169,277,189,190,170,207,278,208,287,170,247,262,181,209,209,134,218,211}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Magmar,PokemonMove.EmberFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Magmar, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {226,220,346,197,122,104,228,230,269,226,210,122,336,212,284,213,95,177,219,212}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Jolteon,PokemonMove.ThunderShockFast,PokemonMove.Thunderbolt), new PokemonMoveSet {Pokemon=PokemonId.Jolteon, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunderbolt, RankVsTypes = new int[] {220,213,147,198,297,230,220,217,326,82,205,237,196,207,273,206,142,234,212,214}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Ninetales,PokemonMove.FeintAttackFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Ninetales, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {229,191,300,199,166,152,280,234,272,229,168,151,301,174,236,267,127,216,220,216}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Poliwrath,PokemonMove.BubbleFast,PokemonMove.IcePunch), new PokemonMoveSet {Pokemon=PokemonId.Poliwrath, Move1=PokemonMove.BubbleFast,Move2 = PokemonMove.IcePunch, RankVsTypes = new int[] {230,161,222,280,270,224,232,236,154,240,292,177,135,219,177,158,198,304,221,217}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Omastar,PokemonMove.RockThrowFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Omastar, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {169,72,235,279,376,136,337,161,274,123,217,208,185,220,235,217,254,248,222,219}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Hypno,PokemonMove.ConfusionFast,PokemonMove.Psyshock), new PokemonMoveSet {Pokemon=PokemonId.Hypno, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psyshock, RankVsTypes = new int[] {215,206,210,189,238,222,124,149,199,215,204,287,193,265,195,345,265,226,209,219}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Nidoking,PokemonMove.FuryCutterFast,PokemonMove.Megahorn), new PokemonMoveSet {Pokemon=PokemonId.Nidoking, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.Megahorn, RankVsTypes = new int[] {222,282,265,140,188,301,227,157,266,285,202,168,143,282,200,137,268,239,214,220}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Wigglytuff,PokemonMove.FeintAttackFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Wigglytuff, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {252,237,230,215,266,251,212,319,231,243,159,187,215,106,123,124,303,272,240,220}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venomoth,PokemonMove.BugBiteFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Venomoth, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {233,325,219,203,79,242,145,167,219,328,215,174,280,275,208,152,279,232,224,221}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Kangaskhan,PokemonMove.LowKickFast,PokemonMove.BrickBreak), new PokemonMoveSet {Pokemon=PokemonId.Kangaskhan, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.BrickBreak, RankVsTypes = new int[] {154,215,212,195,251,176,303,301,209,287,291,314,142,218,204,140,139,303,217,225}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electabuzz,PokemonMove.ThunderShockFast,PokemonMove.Thunderbolt), new PokemonMoveSet {Pokemon=PokemonId.Electabuzz, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunderbolt, RankVsTypes = new int[] {235,221,158,212,307,244,237,240,337,100,218,248,207,221,291,218,160,251,226,228}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Venomoth,PokemonMove.BugBiteFast,PokemonMove.PoisonFang), new PokemonMoveSet {Pokemon=PokemonId.Venomoth, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.PoisonFang, RankVsTypes = new int[] {232,337,218,202,78,241,176,241,218,343,214,173,279,292,207,151,278,252,223,229}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Omastar,PokemonMove.RockThrowFast,PokemonMove.RockSlide), new PokemonMoveSet {Pokemon=PokemonId.Omastar, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.RockSlide, RankVsTypes = new int[] {175,78,228,291,369,124,368,172,349,104,231,182,214,237,221,235,294,256,238,230}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Pidgeot,PokemonMove.SteelWingFast,PokemonMove.Hurricane), new PokemonMoveSet {Pokemon=PokemonId.Pidgeot, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.Hurricane, RankVsTypes = new int[] {240,268,259,347,187,262,213,243,163,231,221,164,258,156,213,222,284,201,229,230}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Kingler,PokemonMove.MetalClawFast,PokemonMove.ViceGrip), new PokemonMoveSet {Pokemon=PokemonId.Kingler, Move1=PokemonMove.MetalClawFast,Move2 = PokemonMove.ViceGrip, RankVsTypes = new int[] {243,225,225,355,309,116,241,248,225,233,223,254,161,231,215,224,225,179,232,230}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venomoth,PokemonMove.BugBiteFast,PokemonMove.BugBuzz), new PokemonMoveSet {Pokemon=PokemonId.Venomoth, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.BugBuzz, RankVsTypes = new int[] {234,338,220,204,80,243,177,242,220,344,216,175,281,293,209,153,280,253,225,231}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Kingler,PokemonMove.MetalClawFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Kingler, Move1=PokemonMove.MetalClawFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {244,226,226,356,310,117,242,249,226,234,224,255,162,232,216,225,226,180,233,231}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kingler,PokemonMove.MetalClawFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Kingler, Move1=PokemonMove.MetalClawFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {245,227,227,357,311,118,243,250,227,235,225,256,163,233,217,226,227,181,234,232}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Seaking,PokemonMove.PoisonJabFast,PokemonMove.Megahorn), new PokemonMoveSet {Pokemon=PokemonId.Seaking, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.Megahorn, RankVsTypes = new int[] {241,177,167,288,258,189,246,306,262,238,198,249,259,294,214,204,223,184,230,233}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Jolteon,PokemonMove.ThunderShockFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Jolteon, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {242,223,168,214,312,247,240,246,347,102,222,251,211,229,299,223,165,255,231,233}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Rhydon,PokemonMove.MudSlapFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Rhydon, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {191,137,331,141,364,256,348,119,308,171,233,236,146,238,222,238,297,258,239,235}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Tangela,PokemonMove.VineWhipFast,PokemonMove.PowerWhip), new PokemonMoveSet {Pokemon=PokemonId.Tangela, Move1=PokemonMove.VineWhipFast,Move2 = PokemonMove.PowerWhip, RankVsTypes = new int[] {221,329,90,138,248,302,221,366,95,335,206,370,140,208,274,207,267,235,213,235}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Seaking,PokemonMove.PoisonJabFast,PokemonMove.DrillRun), new PokemonMoveSet {Pokemon=PokemonId.Seaking, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.DrillRun, RankVsTypes = new int[] {247,176,171,294,263,192,245,279,287,237,227,258,243,297,219,230,190,183,236,235}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Rapidash,PokemonMove.EmberFast,PokemonMove.HeatWave), new PokemonMoveSet {Pokemon=PokemonId.Rapidash, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.HeatWave, RankVsTypes = new int[] {258,239,362,217,141,127,254,262,288,246,239,138,358,243,308,248,115,195,244,236}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Aerodactyl,PokemonMove.SteelWingFast,PokemonMove.IronHead), new PokemonMoveSet {Pokemon=PokemonId.Aerodactyl, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.IronHead, RankVsTypes = new int[] {174,232,356,359,264,246,247,171,228,180,228,191,210,235,220,232,341,185,237,239}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Seaking,PokemonMove.PoisonJabFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Seaking, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {246,175,170,293,262,191,244,310,286,236,226,257,288,296,218,229,228,182,235,241}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electabuzz,PokemonMove.ThunderShockFast,PokemonMove.ThunderPunch), new PokemonMoveSet {Pokemon=PokemonId.Electabuzz, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.ThunderPunch, RankVsTypes = new int[] {253,229,174,220,316,252,250,259,351,107,234,261,216,240,303,241,170,262,241,241}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Golem,PokemonMove.RockThrowFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Golem, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {179,133,364,169,374,255,377,130,359,109,240,197,172,244,228,249,348,266,245,244}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Tangela,PokemonMove.VineWhipFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Tangela, Move1=PokemonMove.VineWhipFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {238,334,102,150,217,316,238,371,101,338,219,373,152,222,288,220,282,247,227,244}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Tauros,PokemonMove.ZenHeadbuttFast,PokemonMove.IronHead), new PokemonMoveSet {Pokemon=PokemonId.Tauros, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.IronHead, RankVsTypes = new int[] {255,253,246,241,267,228,272,191,234,245,285,263,194,166,226,289,299,231,242,244}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Rapidash,PokemonMove.EmberFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Rapidash, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {271,249,369,232,151,138,263,267,294,252,250,141,368,250,318,257,120,203,250,244}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Magmar,PokemonMove.EmberFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Magmar, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {273,250,370,233,152,139,265,269,295,254,251,142,369,252,319,258,121,204,252,246}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Electabuzz,PokemonMove.LowKickFast,PokemonMove.Thunderbolt), new PokemonMoveSet {Pokemon=PokemonId.Electabuzz, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.Thunderbolt, RankVsTypes = new int[] {236,238,199,213,309,245,261,284,338,159,266,289,208,266,293,219,161,284,247,248}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Tangela,PokemonMove.VineWhipFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Tangela, Move1=PokemonMove.VineWhipFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {239,339,103,151,260,317,239,372,102,345,220,375,153,223,293,221,283,254,228,248}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dewgong,PokemonMove.IceShardFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Dewgong, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {256,308,236,292,261,211,321,260,167,184,235,264,285,241,162,246,300,263,243,249}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golduck,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Golduck, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {272,201,194,299,315,213,193,180,243,253,329,275,237,251,237,334,251,269,251,252}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Tauros,PokemonMove.TackleFast,PokemonMove.IronHead), new PokemonMoveSet {Pokemon=PokemonId.Tauros, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.IronHead, RankVsTypes = new int[] {259,267,256,261,269,226,330,263,237,248,242,266,213,206,229,250,301,229,246,253}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Golduck,PokemonMove.ConfusionFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Golduck, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {274,170,221,301,360,217,224,225,210,257,293,278,197,256,280,296,224,273,254,253}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Weezing,PokemonMove.AcidFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Weezing, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {281,260,251,244,160,280,206,245,340,266,299,220,282,247,251,265,281,165,263,253}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Aerodactyl,PokemonMove.BiteFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Aerodactyl, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {193,192,309,315,274,335,304,185,246,199,175,213,311,184,241,292,313,300,253,254}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Magmar,PokemonMove.KarateChopFast,PokemonMove.Flamethrower), new PokemonMoveSet {Pokemon=PokemonId.Magmar, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.Flamethrower, RankVsTypes = new int[] {251,235,354,246,190,153,279,298,298,281,283,181,329,276,301,239,128,240,267,254}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Weezing,PokemonMove.AcidFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Weezing, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {280,259,250,243,159,279,205,252,345,265,300,219,284,257,250,264,285,164,262,254}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electabuzz,PokemonMove.LowKickFast,PokemonMove.ThunderPunch), new PokemonMoveSet {Pokemon=PokemonId.Electabuzz, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.ThunderPunch, RankVsTypes = new int[] {254,255,207,222,317,253,277,293,352,160,279,298,217,270,304,242,171,292,260,259}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Tauros,PokemonMove.ZenHeadbuttFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Tauros, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {277,236,247,225,278,277,273,192,252,260,321,282,230,188,248,326,271,277,259,259}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Pinsir,PokemonMove.FuryCutterFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Pinsir, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {267,350,233,227,144,263,267,324,179,356,161,272,299,318,232,172,306,322,248,260}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Jolteon,PokemonMove.ThunderShockFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Jolteon, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {275,248,188,245,335,273,270,275,369,124,255,279,240,258,322,260,188,275,256,260}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Scyther,PokemonMove.FuryCutterFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Scyther, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {270,353,234,309,94,330,200,326,122,357,167,212,362,320,234,178,310,323,249,261}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Aerodactyl,PokemonMove.BiteFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Aerodactyl, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {199,195,315,320,276,339,339,194,250,203,174,215,310,183,245,336,312,328,257,263}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Primeape,PokemonMove.LowKickFast,PokemonMove.CrossChop), new PokemonMoveSet {Pokemon=PokemonId.Primeape, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.CrossChop, RankVsTypes = new int[] {201,258,249,242,280,212,278,339,253,362,386,288,127,327,249,122,187,377,261,263}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kangaskhan,PokemonMove.LowKickFast,PokemonMove.Stomp), new PokemonMoveSet {Pokemon=PokemonId.Kangaskhan, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.Stomp, RankVsTypes = new int[] {249,247,242,237,275,249,335,292,248,275,278,297,239,261,243,233,243,290,255,263}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Tauros,PokemonMove.ZenHeadbuttFast,PokemonMove.HornAttack), new PokemonMoveSet {Pokemon=PokemonId.Tauros, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.HornAttack, RankVsTypes = new int[] {276,252,245,240,277,276,271,190,251,259,334,281,241,187,247,337,315,276,258,264}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Magmar,PokemonMove.EmberFast,PokemonMove.FirePunch), new PokemonMoveSet {Pokemon=PokemonId.Magmar, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.FirePunch, RankVsTypes = new int[] {295,271,383,262,176,163,292,288,310,274,273,156,385,268,341,275,130,225,276,265}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kangaskhan,PokemonMove.LowKickFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Kangaskhan, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {248,222,258,210,313,248,347,278,258,323,306,357,187,236,260,231,193,308,275,266}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hypno,PokemonMove.ConfusionFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Hypno, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {307,262,254,250,282,286,169,218,254,270,176,345,250,283,257,385,270,279,268,267}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Rapidash,PokemonMove.EmberFast,PokemonMove.DrillRun), new PokemonMoveSet {Pokemon=PokemonId.Rapidash, Move1=PokemonMove.EmberFast,Move2 = PokemonMove.DrillRun, RankVsTypes = new int[] {311,212,376,238,191,178,313,276,334,290,295,169,322,287,323,300,147,244,295,268}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Omastar,PokemonMove.RockThrowFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Omastar, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {216,102,262,335,392,168,402,211,387,147,282,227,257,273,265,283,325,294,283,269}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Parasect,PokemonMove.BugBiteFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Parasect, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {286,411,181,186,100,344,262,388,116,404,180,343,297,314,254,190,318,321,266,272}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Rapidash,PokemonMove.LowKickFast,PokemonMove.HeatWave), new PokemonMoveSet {Pokemon=PokemonId.Rapidash, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.HeatWave, RankVsTypes = new int[] {264,246,367,273,208,175,300,314,319,309,311,225,333,299,313,254,137,265,285,274}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Parasect,PokemonMove.BugBiteFast,PokemonMove.CrossPoison), new PokemonMoveSet {Pokemon=PokemonId.Parasect, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.CrossPoison, RankVsTypes = new int[] {284,409,195,184,98,342,281,386,128,402,178,341,314,328,252,188,316,335,264,275}}}      ,
{GetMoveSetCombinationIndex(PokemonId.Electabuzz,PokemonMove.ThunderShockFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Electabuzz, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {291,265,205,267,351,293,291,286,380,145,270,291,252,267,339,271,194,286,272,275}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Tauros,PokemonMove.TackleFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Tauros, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {294,243,257,234,284,296,351,271,257,273,272,293,278,259,259,274,272,288,274,275}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Parasect,PokemonMove.BugBiteFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Parasect, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {285,410,196,185,99,343,282,387,129,403,179,342,315,329,253,189,317,338,265,276}}}        ,
{GetMoveSetCombinationIndex(PokemonId.Scyther,PokemonMove.SteelWingFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Scyther, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {299,373,290,354,148,321,181,311,145,348,232,231,352,298,263,236,324,260,280,276}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Weezing,PokemonMove.TackleFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Weezing, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {304,279,268,275,247,303,231,221,329,283,307,240,291,260,272,299,295,245,287,276}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Magneton,PokemonMove.SparkFast,PokemonMove.FlashCannon), new PokemonMoveSet {Pokemon=PokemonId.Magneton, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.FlashCannon, RankVsTypes = new int[] {260,384,267,307,285,220,374,264,423,157,244,267,188,307,261,318,207,217,317,277}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Weezing,PokemonMove.TackleFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Weezing, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {310,281,270,276,249,304,223,224,330,284,310,241,295,263,275,298,298,236,288,277}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Aerodactyl,PokemonMove.SteelWingFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Aerodactyl, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {217,242,365,363,287,309,297,212,260,217,281,230,265,286,264,282,377,238,282,278}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Magneton,PokemonMove.SparkFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Magneton, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {257,344,229,303,319,257,371,261,439,112,236,265,224,300,306,311,178,264,311,278}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Raichu,PokemonMove.SparkFast,PokemonMove.ThunderPunch), new PokemonMoveSet {Pokemon=PokemonId.Raichu, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.ThunderPunch, RankVsTypes = new int[] {296,269,206,269,353,297,295,291,385,146,277,296,255,269,345,279,197,289,277,278}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golduck,PokemonMove.ConfusionFast,PokemonMove.IceBeam), new PokemonMoveSet {Pokemon=PokemonId.Golduck, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.IceBeam, RankVsTypes = new int[] {302,251,244,337,306,275,266,270,233,244,312,312,262,281,223,312,269,298,286,278}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Rhydon,PokemonMove.MudSlapFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Rhydon, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {237,162,380,146,422,357,354,121,317,297,289,371,151,284,278,294,263,302,291,280}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Jynx,PokemonMove.FrostBreathFast,PokemonMove.Psyshock), new PokemonMoveSet {Pokemon=PokemonId.Jynx, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.Psyshock, RankVsTypes = new int[] {289,362,316,253,231,274,269,274,194,212,190,350,318,335,190,343,368,283,271,280}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lickitung,PokemonMove.ZenHeadbuttFast,PokemonMove.PowerWhip), new PokemonMoveSet {Pokemon=PokemonId.Lickitung, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.PowerWhip, RankVsTypes = new int[] {297,286,237,265,301,298,308,229,242,289,328,317,236,202,283,333,322,291,278,281}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Raichu,PokemonMove.ThunderShockFast,PokemonMove.ThunderPunch), new PokemonMoveSet {Pokemon=PokemonId.Raichu, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.ThunderPunch, RankVsTypes = new int[] {300,270,208,271,358,299,296,295,383,152,280,299,256,272,350,280,199,293,281,281}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Rapidash,PokemonMove.LowKickFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Rapidash, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {278,261,377,281,215,180,310,318,331,312,316,228,342,309,324,262,149,270,292,282}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Jynx,PokemonMove.FrostBreathFast,PokemonMove.DrainingKiss), new PokemonMoveSet {Pokemon=PokemonId.Jynx, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.DrainingKiss, RankVsTypes = new int[] {287,368,324,251,229,289,288,281,192,210,188,348,316,333,188,341,366,281,269,282}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Magneton,PokemonMove.ThunderShockFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Magneton, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {263,346,232,308,325,260,372,265,438,121,247,270,231,306,310,317,183,268,316,283}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Magneton,PokemonMove.ThunderShockFast,PokemonMove.FlashCannon), new PokemonMoveSet {Pokemon=PokemonId.Magneton, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.FlashCannon, RankVsTypes = new int[] {269,391,321,314,281,214,375,266,415,176,249,273,183,310,256,319,230,212,320,283}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Jynx,PokemonMove.FrostBreathFast,PokemonMove.IcePunch), new PokemonMoveSet {Pokemon=PokemonId.Jynx, Move1=PokemonMove.FrostBreathFast,Move2 = PokemonMove.IcePunch, RankVsTypes = new int[] {288,369,325,252,230,290,289,282,193,211,189,349,317,334,189,342,367,282,270,283}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Tauros,PokemonMove.TackleFast,PokemonMove.HornAttack), new PokemonMoveSet {Pokemon=PokemonId.Tauros, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.HornAttack, RankVsTypes = new int[] {293,266,255,260,283,295,350,287,256,272,271,292,321,271,258,273,320,287,273,283}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Scyther,PokemonMove.FuryCutterFast,PokemonMove.BugBuzz), new PokemonMoveSet {Pokemon=PokemonId.Scyther, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.BugBuzz, RankVsTypes = new int[] {298,374,261,331,109,352,219,352,140,375,194,229,384,341,262,201,323,347,279,283}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Lickitung,PokemonMove.ZenHeadbuttFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Lickitung, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {301,273,263,270,292,300,306,227,264,277,326,306,267,213,267,330,326,295,284,284}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Scyther,PokemonMove.SteelWingFast,PokemonMove.BugBuzz), new PokemonMoveSet {Pokemon=PokemonId.Scyther, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.BugBuzz, RankVsTypes = new int[] {305,385,298,364,161,323,184,316,152,351,245,244,355,302,276,251,328,261,289,284}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arbok,PokemonMove.BiteFast,PokemonMove.GunkShot), new PokemonMoveSet {Pokemon=PokemonId.Arbok, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.GunkShot, RankVsTypes = new int[] {308,283,271,278,214,307,264,272,364,286,320,245,304,280,277,322,309,230,290,285}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Aerodactyl,PokemonMove.SteelWingFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Aerodactyl, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {227,230,392,389,299,308,311,231,271,221,294,238,264,285,281,297,394,237,293,287}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Rhydon,PokemonMove.RockSmashFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Rhydon, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {231,205,359,226,371,288,382,232,365,224,315,283,203,308,290,281,336,316,301,290}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Pidgeot,PokemonMove.SteelWingFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Pidgeot, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {312,330,347,393,250,311,305,302,213,291,296,242,270,216,285,301,332,242,296,291}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golbat,PokemonMove.BiteFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Golbat, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {322,301,286,352,201,375,216,254,283,303,304,184,349,227,297,370,289,313,307,291}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Primeape,PokemonMove.KarateChopFast,PokemonMove.CrossChop), new PokemonMoveSet {Pokemon=PokemonId.Primeape, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.CrossChop, RankVsTypes = new int[] {228,288,276,286,302,239,316,369,276,382,404,320,157,357,287,157,211,393,299,292}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Raichu,PokemonMove.SparkFast,PokemonMove.BrickBreak), new PokemonMoveSet {Pokemon=PokemonId.Raichu, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.BrickBreak, RankVsTypes = new int[] {283,289,239,255,346,281,317,329,376,198,330,334,246,321,329,266,192,325,300,292}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Golbat,PokemonMove.BiteFast,PokemonMove.PoisonFang), new PokemonMoveSet {Pokemon=PokemonId.Golbat, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.PoisonFang, RankVsTypes = new int[] {321,300,285,351,200,374,248,253,282,302,303,183,348,226,296,369,288,312,306,292}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Pidgeot,PokemonMove.SteelWingFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Pidgeot, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {313,333,350,394,254,312,309,303,214,292,297,246,271,217,286,302,333,243,297,293}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Lickitung,PokemonMove.ZenHeadbuttFast,PokemonMove.Stomp), new PokemonMoveSet {Pokemon=PokemonId.Lickitung, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Stomp, RankVsTypes = new int[] {309,285,274,282,300,310,307,228,273,288,361,316,268,214,282,359,331,305,294,294}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Golbat,PokemonMove.BiteFast,PokemonMove.OminousWind), new PokemonMoveSet {Pokemon=PokemonId.Golbat, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.OminousWind, RankVsTypes = new int[] {323,302,287,353,202,376,249,255,284,304,305,185,350,228,298,371,290,314,308,294}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Raichu,PokemonMove.SparkFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Raichu, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {314,287,216,287,366,313,315,304,392,164,298,318,273,288,358,303,216,306,298,296}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Electabuzz,PokemonMove.LowKickFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Electabuzz, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {292,296,240,269,352,294,319,330,381,220,331,335,253,322,340,272,195,326,302,298}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kangaskhan,PokemonMove.MudSlapFast,PokemonMove.BrickBreak), new PokemonMoveSet {Pokemon=PokemonId.Kangaskhan, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.BrickBreak, RankVsTypes = new int[] {265,277,284,274,326,261,361,334,281,347,364,378,209,289,295,255,219,358,304,299}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arbok,PokemonMove.BiteFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Arbok, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {318,297,281,289,227,319,287,285,378,298,337,252,320,291,294,340,319,246,303,299}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Pinsir,PokemonMove.FuryCutterFast,PokemonMove.Submission), new PokemonMoveSet {Pokemon=PokemonId.Pinsir, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.Submission, RankVsTypes = new int[] {268,351,289,297,235,264,268,374,232,389,264,352,300,369,300,234,249,373,310,301}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Gengar,PokemonMove.SuckerPunchFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Gengar, Move1=PokemonMove.SuckerPunchFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {266,309,295,304,252,327,234,214,384,311,339,214,323,362,307,401,321,274,318,303}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Magmar,PokemonMove.KarateChopFast,PokemonMove.FirePunch), new PokemonMoveSet {Pokemon=PokemonId.Magmar, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.FirePunch, RankVsTypes = new int[] {315,294,396,300,228,200,328,333,350,317,333,234,383,325,359,304,173,280,313,303}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Raichu,PokemonMove.ThunderShockFast,PokemonMove.BrickBreak), new PokemonMoveSet {Pokemon=PokemonId.Raichu, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.BrickBreak, RankVsTypes = new int[] {279,304,264,254,343,278,324,357,373,241,358,364,245,348,327,263,191,350,309,304}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Raichu,PokemonMove.ThunderShockFast,PokemonMove.Thunder), new PokemonMoveSet {Pokemon=PokemonId.Raichu, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.Thunder, RankVsTypes = new int[] {320,299,223,298,370,320,322,309,401,174,308,321,286,295,370,309,229,309,305,304}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Scyther,PokemonMove.SteelWingFast,PokemonMove.NightSlash), new PokemonMoveSet {Pokemon=PokemonId.Scyther, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.NightSlash, RankVsTypes = new int[] {326,396,363,405,209,322,183,315,168,350,313,262,354,301,302,313,346,259,312,305}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Magmar,PokemonMove.KarateChopFast,PokemonMove.FireBlast), new PokemonMoveSet {Pokemon=PokemonId.Magmar, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.FireBlast, RankVsTypes = new int[] {303,284,390,305,244,208,331,347,355,324,340,259,361,340,355,291,181,297,319,307}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Gengar,PokemonMove.SuckerPunchFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Gengar, Move1=PokemonMove.SuckerPunchFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {319,313,314,319,279,338,230,200,370,316,327,221,307,319,321,423,311,299,330,308}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electrode,PokemonMove.SparkFast,PokemonMove.Thunderbolt), new PokemonMoveSet {Pokemon=PokemonId.Electrode, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.Thunderbolt, RankVsTypes = new int[] {327,306,231,306,375,325,329,317,407,185,314,325,294,305,375,314,235,315,314,310}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Seaking,PokemonMove.PeckFast,PokemonMove.DrillRun), new PokemonMoveSet {Pokemon=PokemonId.Seaking, Move1=PokemonMove.PeckFast,Move2 = PokemonMove.DrillRun, RankVsTypes = new int[] {344,211,253,344,378,285,327,296,303,353,336,328,272,326,326,339,218,334,335,311}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arbok,PokemonMove.AcidFast,PokemonMove.GunkShot), new PokemonMoveSet {Pokemon=PokemonId.Arbok, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.GunkShot, RankVsTypes = new int[] {329,307,293,302,213,326,260,322,406,310,377,271,359,370,305,316,347,194,315,312}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Beedrill,PokemonMove.BugBiteFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Beedrill, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {334,370,302,311,145,332,218,325,322,372,346,274,392,372,311,285,353,249,324,312}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Rapidash,PokemonMove.LowKickFast,PokemonMove.DrillRun), new PokemonMoveSet {Pokemon=PokemonId.Rapidash, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.DrillRun, RankVsTypes = new int[] {328,209,379,266,320,258,344,300,375,364,345,347,308,342,325,315,189,296,334,313}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dewgong,PokemonMove.IceShardFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Dewgong, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {332,352,306,365,321,268,378,320,238,250,318,329,364,312,230,323,350,319,322,316}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dewgong,PokemonMove.IceShardFast,PokemonMove.AquaJet), new PokemonMoveSet {Pokemon=PokemonId.Dewgong, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.AquaJet, RankVsTypes = new int[] {333,332,307,366,322,269,379,321,239,251,319,330,365,313,231,324,351,320,323,316}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Rhydon,PokemonMove.MudSlapFast,PokemonMove.Megahorn), new PokemonMoveSet {Pokemon=PokemonId.Rhydon, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.Megahorn, RankVsTypes = new int[] {282,245,400,200,390,380,403,198,356,321,284,368,200,354,314,288,345,361,326,317}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Seaking,PokemonMove.PeckFast,PokemonMove.Megahorn), new PokemonMoveSet {Pokemon=PokemonId.Seaking, Move1=PokemonMove.PeckFast,Move2 = PokemonMove.Megahorn, RankVsTypes = new int[] {336,280,241,386,318,272,325,363,297,333,286,311,337,350,312,293,314,357,325,318}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Beedrill,PokemonMove.PoisonJabFast,PokemonMove.SludgeBomb), new PokemonMoveSet {Pokemon=PokemonId.Beedrill, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.SludgeBomb, RankVsTypes = new int[] {338,354,310,316,153,336,199,331,371,358,383,276,413,375,316,331,358,200,327,318}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Kangaskhan,PokemonMove.MudSlapFast,PokemonMove.Stomp), new PokemonMoveSet {Pokemon=PokemonId.Kangaskhan, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.Stomp, RankVsTypes = new int[] {330,298,297,290,342,329,370,307,293,319,317,344,334,304,309,321,327,318,321,319}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Magneton,PokemonMove.SparkFast,PokemonMove.MagnetBomb), new PokemonMoveSet {Pokemon=PokemonId.Magneton, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.MagnetBomb, RankVsTypes = new int[] {306,383,266,346,363,306,404,299,450,156,288,313,263,352,357,362,206,301,362,320}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arbok,PokemonMove.AcidFast,PokemonMove.SludgeWave), new PokemonMoveSet {Pokemon=PokemonId.Arbok, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.SludgeWave, RankVsTypes = new int[] {339,312,311,317,216,337,276,335,416,314,380,280,372,376,317,332,359,205,328,322}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Starmie,PokemonMove.QuickAttackFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Starmie, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {342,224,283,367,400,292,290,336,275,318,269,382,305,392,360,375,291,329,332,324}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electrode,PokemonMove.SparkFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Electrode, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {341,315,243,324,385,340,338,332,420,206,332,338,312,324,390,335,248,327,331,325}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electrode,PokemonMove.TackleFast,PokemonMove.Thunderbolt), new PokemonMoveSet {Pokemon=PokemonId.Electrode, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.Thunderbolt, RankVsTypes = new int[] {343,316,272,295,368,341,343,338,395,230,335,339,340,355,368,338,277,330,333,329}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Scyther,PokemonMove.FuryCutterFast,PokemonMove.NightSlash), new PokemonMoveSet {Pokemon=PokemonId.Scyther, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.NightSlash, RankVsTypes = new int[] {348,403,323,373,170,390,293,383,197,398,265,290,418,332,334,269,362,383,339,330}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Rhydon,PokemonMove.RockSmashFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Rhydon, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {290,233,406,219,433,371,385,219,368,340,371,401,199,361,349,329,308,364,352,331}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Jynx,PokemonMove.PoundFast,PokemonMove.Psyshock), new PokemonMoveSet {Pokemon=PokemonId.Jynx, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Psyshock, RankVsTypes = new int[] {340,360,313,318,332,270,294,289,301,315,262,385,386,383,320,382,406,324,329,332}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Beedrill,PokemonMove.PoisonJabFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Beedrill, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {352,371,329,329,177,350,214,345,386,373,399,294,423,385,337,347,375,218,342,334}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Beedrill,PokemonMove.PoisonJabFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Beedrill, Move1=PokemonMove.PoisonJabFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {353,372,330,330,178,351,215,346,382,374,394,295,420,386,338,346,376,219,343,334}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Butterfree,PokemonMove.BugBiteFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Butterfree, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {355,405,333,380,181,399,225,362,202,400,275,301,425,377,343,277,379,380,345,334}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Jynx,PokemonMove.PoundFast,PokemonMove.IcePunch), new PokemonMoveSet {Pokemon=PokemonId.Jynx, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.IcePunch, RankVsTypes = new int[] {346,366,319,323,303,284,346,341,277,293,261,392,401,398,289,381,409,337,337,337}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Parasect,PokemonMove.FuryCutterFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Parasect, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {350,441,260,263,179,394,352,426,200,433,267,398,382,384,335,270,372,385,340,338}}}     ,
{GetMoveSetCombinationIndex(PokemonId.MrMime,PokemonMove.ZenHeadbuttFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.MrMime, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {361,323,337,336,357,358,165,344,318,327,353,362,325,387,266,397,417,346,351,338}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Parasect,PokemonMove.FuryCutterFast,PokemonMove.SolarBeam), new PokemonMoveSet {Pokemon=PokemonId.Parasect, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.SolarBeam, RankVsTypes = new int[] {351,442,213,264,246,395,312,427,147,434,322,425,332,353,384,328,373,360,341,339}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Pinsir,PokemonMove.FuryCutterFast,PokemonMove.ViceGrip), new PokemonMoveSet {Pokemon=PokemonId.Pinsir, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.ViceGrip, RankVsTypes = new int[] {347,416,322,326,234,346,349,394,255,406,263,351,377,381,333,268,369,382,338,340}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Butterfree,PokemonMove.BugBiteFast,PokemonMove.BugBuzz), new PokemonMoveSet {Pokemon=PokemonId.Butterfree, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.BugBuzz, RankVsTypes = new int[] {354,420,332,379,180,398,298,398,201,407,274,300,424,388,342,276,378,387,344,341}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Porygon,PokemonMove.TackleFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Porygon, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {359,321,288,334,356,355,401,350,316,306,343,360,353,303,348,352,342,344,349,341}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Starmie,PokemonMove.QuickAttackFast,PokemonMove.PowerGem), new PokemonMoveSet {Pokemon=PokemonId.Starmie, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.PowerGem, RankVsTypes = new int[] {366,231,273,382,393,254,342,360,372,300,290,372,351,399,354,394,330,353,357,341}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Seadra,PokemonMove.DragonBreathFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Seadra, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {370,234,308,387,418,305,358,365,289,334,363,369,293,351,332,361,302,374,361,341}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Electrode,PokemonMove.TackleFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Electrode, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {360,322,279,313,380,356,353,351,412,239,344,361,345,366,378,353,292,345,350,342}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Gengar,PokemonMove.SuckerPunchFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Gengar, Move1=PokemonMove.SuckerPunchFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {317,336,353,350,305,368,320,244,397,342,370,250,344,358,364,437,335,369,367,343}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Butterfree,PokemonMove.BugBiteFast,PokemonMove.SignalBeam), new PokemonMoveSet {Pokemon=PokemonId.Butterfree, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.SignalBeam, RankVsTypes = new int[] {356,421,334,381,182,400,299,399,203,408,276,302,426,389,344,278,380,388,346,343}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dugtrio,PokemonMove.MudShotFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Dugtrio, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {376,290,401,205,436,406,362,237,342,386,372,411,204,363,365,363,273,365,368,343}}}     ,
{GetMoveSetCombinationIndex(PokemonId.MrMime,PokemonMove.ZenHeadbuttFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.MrMime, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {368,327,343,342,361,362,167,355,327,331,365,366,330,393,270,402,421,355,359,344}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dugtrio,PokemonMove.MudShotFast,PokemonMove.MudBomb), new PokemonMoveSet {Pokemon=PokemonId.Dugtrio, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.MudBomb, RankVsTypes = new int[] {377,291,402,206,437,407,363,238,343,387,373,412,205,364,366,364,274,366,369,344}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Jynx,PokemonMove.PoundFast,PokemonMove.DrainingKiss), new PokemonMoveSet {Pokemon=PokemonId.Jynx, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.DrainingKiss, RankVsTypes = new int[] {345,365,318,322,345,283,345,340,304,320,260,391,417,419,328,380,408,336,336,345}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Beedrill,PokemonMove.BugBiteFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Beedrill, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {362,423,339,338,184,359,301,358,323,410,347,308,393,390,351,286,385,351,353,345}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Cloyster,PokemonMove.IceShardFast,PokemonMove.HydroPump), new PokemonMoveSet {Pokemon=PokemonId.Cloyster, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.HydroPump, RankVsTypes = new int[] {365,324,348,376,386,287,395,354,263,307,355,363,347,347,330,357,349,349,356,345}}}       ,
{GetMoveSetCombinationIndex(PokemonId.MrMime,PokemonMove.ZenHeadbuttFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.MrMime, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {369,328,344,343,362,363,168,356,328,332,366,367,331,394,271,403,422,356,360,345}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dugtrio,PokemonMove.MudShotFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Dugtrio, Move1=PokemonMove.MudShotFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {378,292,403,207,438,408,364,239,344,383,374,409,206,365,367,365,275,367,370,345}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Beedrill,PokemonMove.BugBiteFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Beedrill, Move1=PokemonMove.BugBiteFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {363,424,340,339,185,360,302,359,324,411,348,309,394,391,352,287,386,352,354,346}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Venomoth,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Venomoth, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {374,382,351,348,268,366,182,251,339,381,422,323,397,359,362,407,395,311,365,346}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kabutops,PokemonMove.FuryCutterFast,PokemonMove.WaterPulse), new PokemonMoveSet {Pokemon=PokemonId.Kabutops, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.WaterPulse, RankVsTypes = new int[] {316,181,389,395,429,314,408,308,341,301,352,374,283,367,407,356,337,370,364,347}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Alakazam,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Alakazam, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {364,326,341,340,359,361,226,297,325,329,367,396,328,379,353,426,387,348,355,348}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Porygon,PokemonMove.TackleFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.Porygon, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {357,319,335,332,354,353,399,348,314,325,341,358,388,343,346,350,381,342,347,349}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Cloyster,PokemonMove.IceShardFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Cloyster, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {367,381,349,377,350,315,397,361,265,280,360,365,387,349,268,358,391,354,358,349}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Porygon,PokemonMove.TackleFast,PokemonMove.SignalBeam), new PokemonMoveSet {Pokemon=PokemonId.Porygon, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.SignalBeam, RankVsTypes = new int[] {358,320,336,333,355,354,400,349,315,326,342,359,389,344,347,351,382,343,348,350}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arbok,PokemonMove.BiteFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Arbok, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {375,335,352,349,304,367,366,305,396,341,368,319,343,290,363,408,334,368,366,350}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Starmie,PokemonMove.QuickAttackFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.Starmie, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {373,295,280,390,401,318,256,313,336,339,359,407,356,400,361,429,338,363,363,351}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Magneton,PokemonMove.ThunderShockFast,PokemonMove.MagnetBomb), new PokemonMoveSet {Pokemon=PokemonId.Magneton, Move1=PokemonMove.ThunderShockFast,Move2 = PokemonMove.MagnetBomb, RankVsTypes = new int[] {349,414,320,375,379,328,415,343,454,214,338,353,298,378,377,387,260,317,394,352}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kabutops,PokemonMove.FuryCutterFast,PokemonMove.AncientPower), new PokemonMoveSet {Pokemon=PokemonId.Kabutops, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.AncientPower, RankVsTypes = new int[] {331,200,366,406,428,267,439,328,431,262,351,331,360,373,376,355,402,376,377,356}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Electrode,PokemonMove.SparkFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Electrode, Move1=PokemonMove.SparkFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {379,341,282,341,395,370,367,373,430,232,375,377,346,368,405,367,286,371,371,357}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Arbok,PokemonMove.AcidFast,PokemonMove.DarkPulse), new PokemonMoveSet {Pokemon=PokemonId.Arbok, Move1=PokemonMove.AcidFast,Move2 = PokemonMove.DarkPulse, RankVsTypes = new int[] {384,345,357,360,265,378,326,353,428,349,400,324,390,360,371,372,383,257,373,357}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Kangaskhan,PokemonMove.MudSlapFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Kangaskhan, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {385,303,358,296,412,379,407,312,353,390,378,418,289,311,372,373,293,372,374,357}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Primeape,PokemonMove.LowKickFast,PokemonMove.LowSweep), new PokemonMoveSet {Pokemon=PokemonId.Primeape, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.LowSweep, RankVsTypes = new int[] {325,347,360,361,372,324,373,417,357,420,430,381,218,404,374,243,296,426,375,358}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dodrio,PokemonMove.FeintAttackFast,PokemonMove.DrillPeck), new PokemonMoveSet {Pokemon=PokemonId.Dodrio, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.DrillPeck, RankVsTypes = new int[] {388,349,368,412,293,416,365,378,296,355,323,307,414,253,381,398,355,391,380,359}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venomoth,PokemonMove.ConfusionFast,PokemonMove.BugBuzz), new PokemonMoveSet {Pokemon=PokemonId.Venomoth, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.BugBuzz, RankVsTypes = new int[] {383,422,355,358,243,377,275,327,348,409,388,326,403,395,369,348,398,359,372,361}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Seaking,PokemonMove.PeckFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Seaking, Move1=PokemonMove.PeckFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {387,310,301,428,377,331,332,377,361,354,381,327,411,371,379,374,352,375,378,363}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Primeape,PokemonMove.LowKickFast,PokemonMove.NightSlash), new PokemonMoveSet {Pokemon=PokemonId.Primeape, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.NightSlash, RankVsTypes = new int[] {335,356,372,369,382,333,383,422,366,425,418,387,233,382,383,256,305,434,382,364}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Persian,PokemonMove.FeintAttackFast,PokemonMove.PlayRough), new PokemonMoveSet {Pokemon=PokemonId.Persian, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.PlayRough, RankVsTypes = new int[] {386,377,361,362,373,381,406,403,358,352,350,379,357,274,336,366,384,386,376,367}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Seadra,PokemonMove.DragonBreathFast,PokemonMove.Blizzard), new PokemonMoveSet {Pokemon=PokemonId.Seadra, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.Blizzard, RankVsTypes = new int[] {391,317,326,411,398,347,386,381,333,337,384,386,370,374,315,377,361,395,386,367}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dodrio,PokemonMove.SteelWingFast,PokemonMove.DrillPeck), new PokemonMoveSet {Pokemon=PokemonId.Dodrio, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.DrillPeck, RankVsTypes = new int[] {392,386,393,430,298,385,360,382,302,361,385,315,374,323,388,378,407,331,387,367}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dodrio,PokemonMove.FeintAttackFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Dodrio, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {389,357,373,413,330,419,396,379,299,359,324,332,415,254,385,421,356,411,383,368}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Primeape,PokemonMove.KarateChopFast,PokemonMove.LowSweep), new PokemonMoveSet {Pokemon=PokemonId.Primeape, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.LowSweep, RankVsTypes = new int[] {337,359,375,370,383,334,384,423,367,424,433,389,238,418,387,259,307,433,385,369}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Dodrio,PokemonMove.FeintAttackFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Dodrio, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {390,358,374,414,331,420,398,380,300,360,325,333,416,255,386,422,357,412,384,369}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Fearow,PokemonMove.PeckFast,PokemonMove.DrillRun), new PokemonMoveSet {Pokemon=PokemonId.Fearow, Move1=PokemonMove.PeckFast,Move2 = PokemonMove.DrillRun, RankVsTypes = new int[] {405,331,382,397,290,425,356,367,313,377,397,304,405,339,399,392,340,384,400,369}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Fearow,PokemonMove.SteelWingFast,PokemonMove.DrillRun), new PokemonMoveSet {Pokemon=PokemonId.Fearow, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.DrillRun, RankVsTypes = new int[] {402,361,405,416,348,392,393,370,309,370,393,354,378,336,396,389,360,340,397,374}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Rhydon,PokemonMove.RockSmashFast,PokemonMove.Megahorn), new PokemonMoveSet {Pokemon=PokemonId.Rhydon, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.Megahorn, RankVsTypes = new int[] {324,343,429,325,403,396,419,364,398,368,369,400,287,414,380,320,401,406,379,375}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dodrio,PokemonMove.SteelWingFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Dodrio, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {396,404,419,434,336,386,387,389,305,365,389,336,375,330,391,383,410,332,390,377}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.BulletPunchFast,PokemonMove.BrickBreak), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.BrickBreak, RankVsTypes = new int[] {371,387,395,391,387,345,390,412,377,414,424,380,254,401,393,307,343,414,392,378}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Pinsir,PokemonMove.RockSmashFast,PokemonMove.XScissor), new PokemonMoveSet {Pokemon=PokemonId.Pinsir, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.XScissor, RankVsTypes = new int[] {380,425,371,368,295,372,380,421,307,418,349,395,398,416,382,327,393,409,381,378}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dodrio,PokemonMove.SteelWingFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Dodrio, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {397,407,420,435,338,387,388,390,306,366,390,340,376,331,392,384,411,333,391,378}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonlee,PokemonMove.LowKickFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Hitmonlee, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {382,342,384,378,391,349,409,413,405,401,427,356,290,402,400,310,364,423,401,380}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Seadra,PokemonMove.DragonBreathFast,PokemonMove.DragonPulse), new PokemonMoveSet {Pokemon=PokemonId.Seadra, Move1=PokemonMove.DragonBreathFast,Move2 = PokemonMove.DragonPulse, RankVsTypes = new int[] {400,318,327,420,425,348,392,392,379,367,392,397,381,380,331,388,371,415,395,380}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Raticate,PokemonMove.BiteFast,PokemonMove.HyperFang), new PokemonMoveSet {Pokemon=PokemonId.Raticate, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.HyperFang, RankVsTypes = new int[] {393,363,378,371,384,382,417,384,374,363,376,388,407,316,389,399,397,392,388,382}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Parasect,PokemonMove.FuryCutterFast,PokemonMove.CrossPoison), new PokemonMoveSet {Pokemon=PokemonId.Parasect, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.CrossPoison, RankVsTypes = new int[] {401,445,328,328,236,424,359,453,270,438,362,429,427,422,395,360,414,362,396,382}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Fearow,PokemonMove.SteelWingFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Fearow, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {403,413,424,437,347,391,389,395,311,369,395,346,379,337,397,390,415,339,398,383}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Fearow,PokemonMove.PeckFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Fearow, Move1=PokemonMove.PeckFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {407,375,385,441,289,426,355,400,320,376,401,303,444,345,401,395,418,389,402,383}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Persian,PokemonMove.FeintAttackFast,PokemonMove.PowerGem), new PokemonMoveSet {Pokemon=PokemonId.Persian, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.PowerGem, RankVsTypes = new int[] {409,340,387,383,394,369,443,402,390,346,357,376,391,278,404,410,389,398,404,383}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Porygon,PokemonMove.QuickAttackFast,PokemonMove.Discharge), new PokemonMoveSet {Pokemon=PokemonId.Porygon, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.Discharge, RankVsTypes = new int[] {394,364,342,399,407,383,412,385,400,330,387,390,396,356,412,379,392,378,389,384}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Fearow,PokemonMove.PeckFast,PokemonMove.Twister), new PokemonMoveSet {Pokemon=PokemonId.Fearow, Move1=PokemonMove.PeckFast,Move2 = PokemonMove.Twister, RankVsTypes = new int[] {408,376,386,442,291,427,357,401,321,378,402,305,445,346,402,396,419,390,403,384}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Fearow,PokemonMove.SteelWingFast,PokemonMove.Twister), new PokemonMoveSet {Pokemon=PokemonId.Fearow, Move1=PokemonMove.SteelWingFast,Move2 = PokemonMove.Twister, RankVsTypes = new int[] {404,418,426,438,349,393,394,396,312,371,396,355,380,338,398,391,416,341,399,385}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Primeape,PokemonMove.KarateChopFast,PokemonMove.NightSlash), new PokemonMoveSet {Pokemon=PokemonId.Primeape, Move1=PokemonMove.KarateChopFast,Move2 = PokemonMove.NightSlash, RankVsTypes = new int[] {372,388,397,392,402,364,405,425,391,432,419,399,266,396,409,295,329,444,408,386}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Electrode,PokemonMove.TackleFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Electrode, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {399,367,381,327,388,389,391,391,422,322,391,393,419,421,394,386,370,381,393,386}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Persian,PokemonMove.FeintAttackFast,PokemonMove.NightSlash), new PokemonMoveSet {Pokemon=PokemonId.Persian, Move1=PokemonMove.FeintAttackFast,Move2 = PokemonMove.NightSlash, RankVsTypes = new int[] {411,379,391,388,397,402,447,405,389,380,356,404,395,277,408,430,388,418,406,393}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Raticate,PokemonMove.BiteFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Raticate, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {410,378,388,384,396,401,430,404,388,379,379,403,409,317,406,412,403,400,405,394}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Marowak,PokemonMove.MudSlapFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Marowak, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {419,348,434,312,450,432,411,323,411,421,412,441,303,410,419,416,344,404,417,396}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Cloyster,PokemonMove.IceShardFast,PokemonMove.IcyWind), new PokemonMoveSet {Pokemon=PokemonId.Cloyster, Move1=PokemonMove.IceShardFast,Move2 = PokemonMove.IcyWind, RankVsTypes = new int[] {412,427,398,422,399,365,423,408,332,336,405,406,428,397,356,404,425,394,407,397}}}       ,
{GetMoveSetCombinationIndex(PokemonId.MrMime,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.MrMime, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {413,390,404,398,406,409,255,407,399,385,408,410,406,430,373,439,439,397,410,399}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Alakazam,PokemonMove.ConfusionFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.Alakazam, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {422,389,399,396,405,405,334,376,394,384,354,437,402,411,411,449,404,396,409,399}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Marowak,PokemonMove.MudSlapFast,PokemonMove.BoneClub), new PokemonMoveSet {Pokemon=PokemonId.Marowak, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.BoneClub, RankVsTypes = new int[] {425,355,436,321,451,434,413,337,419,426,415,444,313,417,423,420,354,410,422,402}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Pinsir,PokemonMove.RockSmashFast,PokemonMove.Submission), new PokemonMoveSet {Pokemon=PokemonId.Pinsir, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.Submission, RankVsTypes = new int[] {381,426,408,401,381,373,381,439,362,445,428,439,399,434,414,368,339,424,412,403}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.BulletPunchFast,PokemonMove.ThunderPunch), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.ThunderPunch, RankVsTypes = new int[] {418,417,394,425,432,403,410,418,433,399,429,383,339,408,434,376,413,417,416,409}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Alakazam,PokemonMove.ConfusionFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Alakazam, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {421,398,415,408,417,415,333,375,414,394,403,442,408,436,403,436,431,405,419,409}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Venomoth,PokemonMove.ConfusionFast,PokemonMove.PoisonFang), new PokemonMoveSet {Pokemon=PokemonId.Venomoth, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.PoisonFang, RankVsTypes = new int[] {427,440,423,418,337,423,286,342,425,431,449,394,439,420,427,444,434,379,425,409}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Raticate,PokemonMove.QuickAttackFast,PokemonMove.HyperFang), new PokemonMoveSet {Pokemon=PokemonId.Raticate, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.HyperFang, RankVsTypes = new int[] {414,392,407,400,411,410,426,410,404,388,407,417,429,409,413,411,426,399,411,410}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Chansey,PokemonMove.PoundFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Chansey, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {415,393,409,402,413,411,435,414,408,391,409,419,433,405,416,413,427,401,413,412}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Raticate,PokemonMove.BiteFast,PokemonMove.Dig), new PokemonMoveSet {Pokemon=PokemonId.Raticate, Move1=PokemonMove.BiteFast,Move2 = PokemonMove.Dig, RankVsTypes = new int[] {423,400,416,409,419,417,452,419,417,395,382,423,412,315,421,443,405,432,420,412}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.RockSmashFast,PokemonMove.BrickBreak), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.BrickBreak, RankVsTypes = new int[] {395,408,421,415,421,384,414,449,421,453,447,432,326,442,425,354,363,447,423,413}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Chansey,PokemonMove.PoundFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.Chansey, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {416,394,410,403,414,412,436,415,409,392,410,420,434,406,417,414,428,402,414,413}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Porygon,PokemonMove.QuickAttackFast,PokemonMove.SignalBeam), new PokemonMoveSet {Pokemon=PokemonId.Porygon, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.SignalBeam, RankVsTypes = new int[] {420,402,414,407,389,414,440,420,413,397,398,422,422,413,420,393,430,408,418,413}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Chansey,PokemonMove.PoundFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Chansey, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {417,395,411,404,415,413,437,416,410,393,411,421,435,407,418,415,429,403,415,414}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonlee,PokemonMove.LowKickFast,PokemonMove.LowSweep), new PokemonMoveSet {Pokemon=PokemonId.Hitmonlee, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.LowSweep, RankVsTypes = new int[] {398,415,425,419,424,388,416,452,426,456,452,430,319,444,428,344,365,451,426,415}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Butterfree,PokemonMove.ConfusionFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Butterfree, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {428,438,427,433,365,437,314,397,335,429,439,405,454,424,430,448,435,416,427,415}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Marowak,PokemonMove.MudSlapFast,PokemonMove.Dig), new PokemonMoveSet {Pokemon=PokemonId.Marowak, Move1=PokemonMove.MudSlapFast,Move2 = PokemonMove.Dig, RankVsTypes = new int[] {432,380,441,345,455,443,421,368,432,442,420,450,338,429,433,431,390,419,431,416}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonlee,PokemonMove.LowKickFast,PokemonMove.Stomp), new PokemonMoveSet {Pokemon=PokemonId.Hitmonlee, Move1=PokemonMove.LowKickFast,Move2 = PokemonMove.Stomp, RankVsTypes = new int[] {406,419,428,421,427,397,420,446,429,454,448,426,324,448,431,349,374,448,429,417}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Porygon,PokemonMove.QuickAttackFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.Porygon, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {424,401,417,410,420,418,429,411,418,396,414,424,430,403,422,419,432,407,421,417}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.BulletPunchFast,PokemonMove.IcePunch), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.IcePunch, RankVsTypes = new int[] {429,444,440,423,404,421,418,428,393,412,437,402,366,425,410,400,436,428,428,418}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Butterfree,PokemonMove.ConfusionFast,PokemonMove.BugBuzz), new PokemonMoveSet {Pokemon=PokemonId.Butterfree, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.BugBuzz, RankVsTypes = new int[] {431,457,430,440,333,442,369,438,346,455,413,408,458,440,432,418,437,436,430,422}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Raticate,PokemonMove.QuickAttackFast,PokemonMove.HyperBeam), new PokemonMoveSet {Pokemon=PokemonId.Raticate, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.HyperBeam, RankVsTypes = new int[] {426,412,422,417,423,422,441,424,424,405,417,427,440,423,426,425,433,413,424,423}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Farfetchd,PokemonMove.CutFast,PokemonMove.LeafBlade), new PokemonMoveSet {Pokemon=PokemonId.Farfetchd, Move1=PokemonMove.CutFast,Move2 = PokemonMove.LeafBlade, RankVsTypes = new int[] {434,431,413,446,410,447,422,437,363,417,421,416,441,415,438,433,438,420,432,425}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.BulletPunchFast,PokemonMove.FirePunch), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.BulletPunchFast,Move2 = PokemonMove.FirePunch, RankVsTypes = new int[] {437,451,449,426,416,404,424,432,434,443,440,384,373,431,442,405,412,435,433,425}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Marowak,PokemonMove.RockSmashFast,PokemonMove.BoneClub), new PokemonMoveSet {Pokemon=PokemonId.Marowak, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.BoneClub, RankVsTypes = new int[] {435,399,448,374,454,441,431,406,436,447,432,455,363,437,439,434,396,430,438,426}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Butterfree,PokemonMove.ConfusionFast,PokemonMove.SignalBeam), new PokemonMoveSet {Pokemon=PokemonId.Butterfree, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.SignalBeam, RankVsTypes = new int[] {438,460,431,453,344,448,376,440,354,457,416,413,460,446,435,424,442,440,434,427}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Marowak,PokemonMove.RockSmashFast,PokemonMove.Dig), new PokemonMoveSet {Pokemon=PokemonId.Marowak, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.Dig, RankVsTypes = new int[] {439,397,451,372,456,450,433,393,440,449,431,457,367,435,440,438,399,429,441,427}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Marowak,PokemonMove.RockSmashFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Marowak, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {433,406,450,385,453,439,434,409,441,450,436,458,371,441,441,432,400,438,442,429}}}     ,
{GetMoveSetCombinationIndex(PokemonId.MrMime,PokemonMove.ConfusionFast,PokemonMove.ShadowBall), new PokemonMoveSet {Pokemon=PokemonId.MrMime, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.ShadowBall, RankVsTypes = new int[] {445,432,435,424,440,433,341,445,437,419,406,440,431,439,415,452,449,425,439,429}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Farfetchd,PokemonMove.CutFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Farfetchd, Move1=PokemonMove.CutFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {440,429,432,457,408,452,427,435,402,415,425,414,461,432,436,440,444,421,435,432}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Farfetchd,PokemonMove.CutFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Farfetchd, Move1=PokemonMove.CutFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {441,430,433,458,409,453,428,436,403,416,426,415,462,433,437,441,445,422,436,433}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Farfetchd,PokemonMove.FuryCutterFast,PokemonMove.LeafBlade), new PokemonMoveSet {Pokemon=PokemonId.Farfetchd, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.LeafBlade, RankVsTypes = new int[] {442,453,412,456,430,451,438,459,360,446,423,438,432,412,452,435,446,427,437,434}}}     ,
{GetMoveSetCombinationIndex(PokemonId.MrMime,PokemonMove.ConfusionFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.MrMime, Move1=PokemonMove.ConfusionFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {444,435,437,429,441,435,336,443,442,423,434,443,438,455,424,453,457,431,443,434}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.RockSmashFast,PokemonMove.ThunderPunch), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.ThunderPunch, RankVsTypes = new int[] {436,433,418,450,448,430,432,447,453,422,446,431,404,438,450,409,424,446,440,435}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.RockSmashFast,PokemonMove.IcePunch), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.IcePunch, RankVsTypes = new int[] {443,455,452,431,426,449,442,456,427,435,451,433,410,447,429,417,440,449,444,439}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Ditto,PokemonMove.PoundFast,PokemonMove.Struggle), new PokemonMoveSet {Pokemon=PokemonId.Ditto, Move1=PokemonMove.PoundFast,Move2 = PokemonMove.Struggle, RankVsTypes = new int[] {447,437,438,432,442,436,455,448,443,428,435,445,456,443,443,445,450,437,445,442}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonlee,PokemonMove.RockSmashFast,PokemonMove.LowSweep), new PokemonMoveSet {Pokemon=PokemonId.Hitmonlee, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.LowSweep, RankVsTypes = new int[] {430,449,445,447,447,428,448,463,449,465,465,453,400,457,448,406,420,464,450,444}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Raticate,PokemonMove.QuickAttackFast,PokemonMove.Dig), new PokemonMoveSet {Pokemon=PokemonId.Raticate, Move1=PokemonMove.QuickAttackFast,Move2 = PokemonMove.Dig, RankVsTypes = new int[] {450,443,439,436,443,440,456,454,444,436,438,446,452,445,444,447,443,439,446,444}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Chansey,PokemonMove.ZenHeadbuttFast,PokemonMove.Psychic), new PokemonMoveSet {Pokemon=PokemonId.Chansey, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psychic, RankVsTypes = new int[] {451,446,442,443,444,444,444,429,445,439,453,447,446,426,445,454,451,441,447,444}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Chansey,PokemonMove.ZenHeadbuttFast,PokemonMove.Psybeam), new PokemonMoveSet {Pokemon=PokemonId.Chansey, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.Psybeam, RankVsTypes = new int[] {452,447,443,444,445,445,445,430,446,440,454,448,447,427,446,456,452,442,448,445}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonlee,PokemonMove.RockSmashFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Hitmonlee, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {446,434,447,451,449,431,454,461,456,451,459,435,421,454,451,427,441,458,453,446}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Chansey,PokemonMove.ZenHeadbuttFast,PokemonMove.DazzlingGleam), new PokemonMoveSet {Pokemon=PokemonId.Chansey, Move1=PokemonMove.ZenHeadbuttFast,Move2 = PokemonMove.DazzlingGleam, RankVsTypes = new int[] {453,448,444,445,446,446,446,431,447,441,455,449,448,428,447,455,453,443,449,446}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonchan,PokemonMove.RockSmashFast,PokemonMove.FirePunch), new PokemonMoveSet {Pokemon=PokemonId.Hitmonchan, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.FirePunch, RankVsTypes = new int[] {449,459,454,449,439,429,449,460,451,460,458,428,436,453,454,428,423,457,452,447}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Pinsir,PokemonMove.RockSmashFast,PokemonMove.ViceGrip), new PokemonMoveSet {Pokemon=PokemonId.Pinsir, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.ViceGrip, RankVsTypes = new int[] {448,461,446,448,435,438,425,458,435,461,442,454,463,458,449,446,447,445,451,448}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Onix,PokemonMove.RockThrowFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Onix, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {455,428,460,455,460,455,463,434,463,413,457,451,451,459,460,458,461,454,460,452}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Onix,PokemonMove.TackleFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Onix, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {454,436,461,454,461,458,461,433,461,427,456,459,455,461,458,457,460,453,458,454}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dugtrio,PokemonMove.SuckerPunchFast,PokemonMove.StoneEdge), new PokemonMoveSet {Pokemon=PokemonId.Dugtrio, Move1=PokemonMove.SuckerPunchFast,Move2 = PokemonMove.StoneEdge, RankVsTypes = new int[] {461,454,457,439,457,457,458,455,458,448,441,456,442,450,455,459,456,459,455,454}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dugtrio,PokemonMove.SuckerPunchFast,PokemonMove.Earthquake), new PokemonMoveSet {Pokemon=PokemonId.Dugtrio, Move1=PokemonMove.SuckerPunchFast,Move2 = PokemonMove.Earthquake, RankVsTypes = new int[] {462,456,458,427,458,461,457,442,457,462,445,463,437,452,456,462,448,460,456,454}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Farfetchd,PokemonMove.FuryCutterFast,PokemonMove.AerialAce), new PokemonMoveSet {Pokemon=PokemonId.Farfetchd, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.AerialAce, RankVsTypes = new int[] {463,464,455,464,431,463,450,464,448,458,443,434,464,449,457,450,458,455,457,454}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Hitmonlee,PokemonMove.RockSmashFast,PokemonMove.Stomp), new PokemonMoveSet {Pokemon=PokemonId.Hitmonlee, Move1=PokemonMove.RockSmashFast,Move2 = PokemonMove.Stomp, RankVsTypes = new int[] {456,458,453,459,452,454,453,462,455,464,464,452,449,462,453,442,454,463,454,456}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Farfetchd,PokemonMove.FuryCutterFast,PokemonMove.AirCutter), new PokemonMoveSet {Pokemon=PokemonId.Farfetchd, Move1=PokemonMove.FuryCutterFast,Move2 = PokemonMove.AirCutter, RankVsTypes = new int[] {464,465,456,465,434,464,451,465,452,459,444,436,465,451,459,451,459,456,459,456}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Onix,PokemonMove.RockThrowFast,PokemonMove.IronHead), new PokemonMoveSet {Pokemon=PokemonId.Onix, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.IronHead, RankVsTypes = new int[] {458,452,464,462,462,456,462,444,462,437,461,461,443,460,462,461,462,452,462,457}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Onix,PokemonMove.TackleFast,PokemonMove.IronHead), new PokemonMoveSet {Pokemon=PokemonId.Onix, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.IronHead, RankVsTypes = new int[] {457,462,465,463,463,460,460,441,460,452,460,464,453,464,461,460,463,450,461,459}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Onix,PokemonMove.RockThrowFast,PokemonMove.RockSlide), new PokemonMoveSet {Pokemon=PokemonId.Onix, Move1=PokemonMove.RockThrowFast,Move2 = PokemonMove.RockSlide, RankVsTypes = new int[] {460,439,462,461,464,459,465,451,465,430,463,460,457,463,465,464,464,462,465,459}}}     ,
{GetMoveSetCombinationIndex(PokemonId.Onix,PokemonMove.TackleFast,PokemonMove.RockSlide), new PokemonMoveSet {Pokemon=PokemonId.Onix, Move1=PokemonMove.TackleFast,Move2 = PokemonMove.RockSlide, RankVsTypes = new int[] {459,450,463,460,465,462,464,450,464,444,462,462,459,465,464,463,465,461,464,460}}}       ,
{GetMoveSetCombinationIndex(PokemonId.Dugtrio,PokemonMove.SuckerPunchFast,PokemonMove.MudBomb), new PokemonMoveSet {Pokemon=PokemonId.Dugtrio, Move1=PokemonMove.SuckerPunchFast,Move2 = PokemonMove.MudBomb, RankVsTypes = new int[] {465,463,459,452,459,465,459,457,459,463,450,465,450,456,463,465,455,465,463,460}}}
        };
        //todo: moveset dps calculations or other rankings
    }
}